//-----------------------------------------------------------------------------
//
// CO22SnapIoMemMapX.cpp
// Copyright (c) 1999 - 2002 by Opto 22
//
// Source for the CO22SnapIoMemMapX ActiveX class.  It is mostly a thin wrapper
// around the O22SnapIoMemMap C++ class. 
// 
//-----------------------------------------------------------------------------


#include "stdafx.h"
#include <comdef.h>

#ifdef WIN32
#ifdef _WINDOWS
#include "OptoSnapIoMemMapX.h"
#endif
#endif

#include "CO22SnapIoMemMapX.h"

#include "CO22SnapIoVariantUtil.h"

/////////////////////////////////////////////////////////////////////////////
// CO22SnapIoMemMapX


STDMETHODIMP CO22SnapIoMemMapX::OpenEnet(BSTR bstrIpAddressArg, int nPort, int nOpenTimeOutMS, int nAutoPUC, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.OpenEnet(OLE2A(bstrIpAddressArg), nPort, nOpenTimeOutMS, nAutoPUC);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::OpenEnet2(BSTR bstrIpAddressArg, int nPort, int nOpenTimeOutMS, int nAutoPUC, int nConnectionType, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.OpenEnet2(OLE2A(bstrIpAddressArg), nPort, nOpenTimeOutMS, nAutoPUC, nConnectionType);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::OpenSerial(int nPort, unsigned char nAddress, int nBaudRate, int nOpenTimeOutMS, int nAutoPUC, int * pnResult)
{
  *pnResult = m_MemMap.OpenSerial(nPort, nAddress, nBaudRate, nOpenTimeOutMS, nAutoPUC);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::OpenSerialPassThru(BSTR bstrIpAddressArg, int nPort, 
	                                                 int nSerialPort, BYTE nSerialAddress, int nSerialBaudRate, int nSerialTwoWire,
                                                   int nOpenTimeOutMS, int nAutoPUC, int nConnectionType, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.OpenSerialPassThru(OLE2A(bstrIpAddressArg), nPort, nSerialPort, nSerialAddress, nSerialBaudRate, (nSerialTwoWire == 0 ? false : true), nOpenTimeOutMS, nAutoPUC, nConnectionType);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::IsOpenDone(int *pnResult)
{
  *pnResult = m_MemMap.IsOpenDone();

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::Close(int *pnResult)
{
  *pnResult = m_MemMap.Close();

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetDigPtState(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtState(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigPtState(int nPoint, int nState, int *pnResult)
{
  *pnResult = m_MemMap.SetDigPtState(nPoint, nState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigPtCounterState(int nPoint, int nState, int *pnResult)
{
  *pnResult = m_MemMap.SetDigPtCounterState(nPoint, nState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigurePoint(int nPoint, int nPointType, int *pnResult)
{
  *pnResult = m_MemMap.ConfigurePoint(nPoint, nPointType);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigBankPointStates(int *pnPts63to32, int *pnPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.GetDigBankPointStates(pnPts63to32, pnPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigBankOnLatchStates(int *pnPts63to32, int *pnPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.GetDigBankOnLatchStates(pnPts63to32, pnPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigBankOffLatchStates(int *pnPts63to32, int *pnPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.GetDigBankOffLatchStates(pnPts63to32, pnPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigBankActCounterStates(int *pnPts63to32, int *pnPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.GetDigBankActCounterStates(pnPts63to32, pnPts31to0);

  return S_OK;
}



STDMETHODIMP CO22SnapIoMemMapX::GetDigBankReadArea(int *pnStatePts63to32, 
                                                   int *pnStatePts31to0, 
                                                   int *pnOnLatchStatePts63to32, 
                                                   int *pnOnLatchStatePts31to0, 
                                                   int *pnOffLatchStatePts63to32, 
                                                   int *pnOffLatchStatePts31to0, 
                                                   int *pnActiveCountersPts63to32, 
                                                   int *pnActiveCountersPts31to0, 
                                                   int *pnResult)
{
  SIOMM_DigBankReadArea Data;

  *pnResult = m_MemMap.GetDigBankReadAreaEx(&Data);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnStatePts63to32          = Data.nStatePts63to32;
    *pnStatePts31to0           = Data.nStatePts31to0;
    *pnOnLatchStatePts63to32   = Data.nOnLatchStatePts63to32;
    *pnOnLatchStatePts31to0    = Data.nOnLatchStatePts31to0;
    *pnOffLatchStatePts63to32  = Data.nOffLatchStatePts63to32;
    *pnOffLatchStatePts31to0   = Data.nOffLatchStatePts31to0;
    *pnActiveCountersPts63to32 = Data.nActiveCountersPts63to32;
    *pnActiveCountersPts31to0  = Data.nActiveCountersPts31to0;
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigBankOnMask(int nPts63to32, int nPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetDigBankOnMask(nPts63to32, nPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigBankOffMask(int nPts63to32, int nPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetDigBankOffMask(nPts63to32, nPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigBankActCounterMask(int nPts63to32, int nPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetDigBankActCounterMask(nPts63to32, nPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigBankDeactCounterMask(int nPts63to32, int nPts31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetDigBankDeactCounterMask(nPts63to32, nPts31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigPtOnLatch(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtOnLatch(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigPtOffLatch(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtOffLatch(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigPtCounterState(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtCounterState(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigPtCounts(int nPoint, int *pnValue, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtCounts(nPoint, pnValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigPtReadArea(int nPoint, int *pnState, int *pnOnLatchState, int *pnOffLatchState, int *pnCounterActive, int *pnCounterData, int *pnResult)
{
  SIOMM_DigPointReadArea Data;

  *pnResult = m_MemMap.GetDigPtReadAreaEx(nPoint, &Data);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnState = Data.nState;
    *pnOnLatchState = Data.nOnLatch;
    *pnOffLatchState = Data.nOffLatch;
    *pnCounterActive = Data.nCounterState;
    *pnCounterData = Data.nCounts;
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadClearDigPtCounts(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.ReadClearDigPtCounts(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ReadClearDigPtOnLatch(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.ReadClearDigPtOnLatch(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ReadClearDigPtOffLatch(int nPoint, int *pnState, int *pnResult)
{
  *pnResult = m_MemMap.ReadClearDigPtOffLatch(nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtValue(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtValue(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtCounts(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtCounts(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtMinValue(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtMinValue(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtMaxValue(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtMaxValue(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtTpoPeriod(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtTpoPeriod(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtReadArea(int nPoint, float *pfValue, 
                                                 float *pfCounts, float *pfMinValue, 
                                                 float *pfMaxValue, int *pnResult)
{
  SIOMM_AnaPointReadArea Data;

  *pnResult = m_MemMap.GetAnaPtReadAreaEx(nPoint, &Data);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pfValue    = Data.fValue ;
    *pfCounts   = Data.fCounts;
    *pfMinValue = Data.fMinValue;
    *pfMaxValue = Data.fMaxValue;
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaPtValue(int nPoint, float fValue, int *pnResult)
{
  *pnResult = m_MemMap.SetAnaPtValue(nPoint, fValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaPtCounts(int nPoint, float fValue, int *pnResult)
{
  *pnResult = m_MemMap.SetAnaPtCounts(nPoint, fValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaPtTpoPeriod(int nPoint, float fValue, int *pnResult)
{
  *pnResult = m_MemMap.SetAnaPtTpoPeriod(nPoint, fValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ReadClearAnaPtMinValue(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.ReadClearAnaPtMinValue(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ReadClearAnaPtMaxValue(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.ReadClearAnaPtMaxValue(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigPtConfiguration(int nPoint, int nPointType, 
                                                      int nFeature, int *pnResult)
{
  *pnResult = m_MemMap.SetDigPtConfiguration(nPoint, nPointType, nFeature);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaPtConfiguration(int nPoint, int nPointType, 
                                                      float fOffset, float fGain, 
                                                      float fHiScale, float fLoScale, 
                                                      int *pnResult)
{
  *pnResult = m_MemMap.SetAnaPtConfiguration(nPoint, nPointType, fOffset, fGain, 
                                             fHiScale, fLoScale);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPtConfiguration2(int  nPoint, 
                                                    int  nPointType, int nFeature, 
                                                    float fOffset, float fGain, 
                                                    float fLoScale, float fHiScale, 
                                                    float fWatchdogValue, int nWatchdogEnabled,
                                                    float fFilterWeight, BSTR bstrName,
                                                    int *pnResult)
{
  USES_CONVERSION; // for string conversion

  SIOMM_PointConfigArea2 PtConfigData;

  PtConfigData.nPointType       = nPointType;
  PtConfigData.nFeature         = nFeature;
  PtConfigData.fOffset          = fOffset;
  PtConfigData.fGain            = fGain;
  PtConfigData.fLoScale         = fLoScale;
  PtConfigData.fHiScale         = fHiScale;
  PtConfigData.fWatchdogValue   = fWatchdogValue;
  PtConfigData.nWatchdogEnabled = nWatchdogEnabled;
  PtConfigData.fFilterWeight    = fFilterWeight;
  strncpy_s((char*)PtConfigData.byName, 16, OLE2A(bstrName), SIOMM_POINT_CONFIG_NAME_SIZE);

  *pnResult = m_MemMap.SetPtConfigurationEx2(nPoint, PtConfigData);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetPtConfiguration(int  nPoint, 
                                                   int  nPointType, int nFeature, 
                                                   float fOffset, float fGain, 
                                                   float fLoScale, float fHiScale, 
                                                   float fWatchdogValue, int nWatchdogEnabled, 
                                                   int *pnResult)
{
  SIOMM_PointConfigArea PtConfigData;

  PtConfigData.nPointType       = nPointType;
  PtConfigData.nFeature         = nFeature;
  PtConfigData.fOffset          = fOffset;
  PtConfigData.fGain            = fGain;
  PtConfigData.fLoScale         = fLoScale;
  PtConfigData.fHiScale         = fHiScale;
  PtConfigData.fWatchdogValue   = fWatchdogValue;
  PtConfigData.nWatchdogEnabled = nWatchdogEnabled;

  *pnResult = m_MemMap.SetPtConfigurationEx(nPoint, PtConfigData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetPtConfiguration2(int  nPoint, int *pnModuleType, 
                                                    int  *pnPointType, int *pnFeature, 
                                                    float *pfOffset, float *pfGain, 
                                                    float *pfLoScale, float *pfHiScale, 
                                                    float *pfWatchdogValue, 
                                                    int  *pnWatchdogEnabled, 
                                                    float *pfFilterWeight, BSTR * pbstrName,
                                                    int  *pnResult)
{
  SIOMM_PointConfigArea2 PtConfigData;

  *pnResult = m_MemMap.GetPtConfigurationEx2(nPoint, &PtConfigData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnModuleType      = PtConfigData.nModuleType;
    *pnPointType       = PtConfigData.nPointType;
    *pnFeature         = PtConfigData.nFeature;
    *pfOffset          = PtConfigData.fOffset;
    *pfGain            = PtConfigData.fGain;
    *pfLoScale         = PtConfigData.fLoScale;
    *pfHiScale         = PtConfigData.fHiScale;
    *pfWatchdogValue   = PtConfigData.fWatchdogValue;
    *pnWatchdogEnabled = PtConfigData.nWatchdogEnabled;
    *pfFilterWeight    = PtConfigData.fFilterWeight;

    // Make sure the point name string is null terminated.
    char pchPtNameTemp[SIOMM_POINT_CONFIG_NAME_SIZE + 1];
    memcpy(pchPtNameTemp, PtConfigData.byName, SIOMM_POINT_CONFIG_NAME_SIZE);
    pchPtNameTemp[SIOMM_POINT_CONFIG_NAME_SIZE] = 0;
    *pbstrName = A2BSTR(pchPtNameTemp);

  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetPtConfiguration(int  nPoint, int *pnModuleType, 
                                                   int  *pnPointType, int *pnFeature, 
                                                   float *pfOffset, float *pfGain, 
                                                   float *pfLoScale, float *pfHiScale, 
                                                   float *pfWatchdogValue, int *pnWatchdogEnabled,
                                                   int  *pnResult)
{
  SIOMM_PointConfigArea PtConfigData;

  *pnResult = m_MemMap.GetPtConfigurationEx(nPoint, &PtConfigData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnModuleType      = PtConfigData.nModuleType;
    *pnPointType       = PtConfigData.nPointType;
    *pnFeature         = PtConfigData.nFeature;
    *pfOffset          = PtConfigData.fOffset;
    *pfGain            = PtConfigData.fGain;
    *pfLoScale         = PtConfigData.fLoScale;
    *pfHiScale         = PtConfigData.fHiScale;
    *pfWatchdogValue   = PtConfigData.fWatchdogValue;
    *pnWatchdogEnabled = PtConfigData.nWatchdogEnabled;
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetPtWatchdog(int nPoint, float fValue, int nEnabled, int *pnResult)
{
  *pnResult = m_MemMap.SetPtWatchdog(nPoint, fValue, nEnabled);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::CalcSetAnaPtOffset(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.CalcSetAnaPtOffset(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::CalcSetAnaPtGain(int nPoint, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.CalcSetAnaPtGain(nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnalogOutputClamp(int nPoint, float fLowClamp, float fHighClamp, int * pnResult)
{
  *pnResult = m_MemMap.SetAnalogOutputClamp(nPoint, fLowClamp, fHighClamp);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogOutputClamp(int nPoint, float * pfLowClamp, float * pfHighClamp, int * pnResult)
{
  *pnResult = m_MemMap.GetAnalogOutputClamp(nPoint, pfLowClamp, pfHighClamp);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigurePointEx(int nModule, int nPoint, int nPointType, int * pnResult)
{
  *pnResult = m_MemMap.ConfigurePoint(nModule, nPoint, nPointType);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetModuleType(int nModule, int nPoint, int * pnModuleType, int * pnResult)
{
  *pnResult = m_MemMap.GetModuleType(nModule, nPoint, pnModuleType);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetPointConfiguration(int nModule, int nPoint, O22_SIOMM_PointConfigArea4 * pData, int * pnResult)
{
  *pnResult = m_MemMap.GetPointConfigurationEx4(nModule, nPoint, pData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetPointGain(int nModule, int nPoint, float * pfGain, int * pnResult)
{
  *pnResult = m_MemMap.GetPointGain(nModule, nPoint, pfGain);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetPointOffset(int nModule, int nPoint, float * pfOffset, int * pnResult)
{
  *pnResult = m_MemMap.GetPointOffset(nModule, nPoint, pfOffset);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointConfiguration(int nModule, int nPoint, O22_SIOMM_PointConfigArea4 PointConfigData, int * pnResult)
{
  *pnResult = m_MemMap.SetPointConfigurationEx4(nModule, nPoint, PointConfigData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointFilterWeight(int nModule, int nPoint, float fFilterWeight, int * pnResult)
{
  *pnResult = m_MemMap.SetPointFilterWeight(nModule, nPoint, fFilterWeight);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointGain(int nModule, int nPoint, float fGain, int * pnResult)
{
  *pnResult = m_MemMap.SetPointGain(nModule, nPoint, fGain);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointName(int nModule, int nPoint, BSTR bstrPointName, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.SetPointName(nModule, nPoint, OLE2A(bstrPointName));

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointOffset(int nModule, int nPoint, float fOffset, int * pnResult)
{
  *pnResult = m_MemMap.SetPointOffset(nModule, nPoint, fOffset);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointScale(int nModule, int nPoint, float fHiScale, float fLoScale, int * pnResult)
{
  *pnResult = m_MemMap.SetPointScale(nModule, nPoint, fHiScale, fLoScale);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetPointWatchdog(int nModule, int nPoint, float fValue, int nEnabled, int * pnResult)
{
  *pnResult = m_MemMap.SetPointWatchdog(nModule, nPoint, fValue, nEnabled);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::CalcSetAnalogPointOffset(int nModule, int nPoint, float * pfValue, int * pnResult)
{
  *pnResult = m_MemMap.CalcSetAnalogPointOffsetEx(nModule, nPoint, pfValue);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::CalcSetAnalogPointGain(int nModule, int nPoint, float * pfValue, int * pnResult)
{
  *pnResult = m_MemMap.CalcSetAnalogPointGainEx(nModule, nPoint, pfValue);

  return S_OK;
}
  
STDMETHODIMP CO22SnapIoMemMapX::SetAnalogOutputClampEx(int nModule, int nPoint, float fLowClamp, float fHighClamp, int * pnResult)
{
  *pnResult = m_MemMap.SetAnalogOutputClamp(nModule, nPoint, fLowClamp, fHighClamp);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogOutputClampEx(int nModule, int nPoint, float * pfLowClamp, float * pfHighClamp, int * pnResult)
{
  *pnResult = m_MemMap.GetAnalogOutputClamp(nModule, nPoint, pfLowClamp, pfHighClamp);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusVersion(int *pnMapVer, int *pnLoaderVersion, 
                                                 int *pnKernelVersion, int *pnResult)
{
  SIOMM_StatusVersion VersionData;

  *pnResult = m_MemMap.GetStatusVersionEx(&VersionData);
  
  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnMapVer        = VersionData.nMapVer;
    *pnLoaderVersion = VersionData.nLoaderVersion;
    *pnKernelVersion = VersionData.nKernelVersion;
  }


  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusHardware(int *pnIoUnitType, 
                                                  unsigned char *pbyHwdVerMonth, 
                                                  unsigned char *pbyHwdVerDay, 
                                                  short *pwHwdVerYear, int *pnRamSize, 
                                                  int *pnResult)
{
  SIOMM_StatusHardware HardwareData;

  *pnResult = m_MemMap.GetStatusHardwareEx(&HardwareData);
  
  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnIoUnitType   = HardwareData.nIoUnitType;
    *pbyHwdVerMonth = HardwareData.byHwdVerMonth;
    *pbyHwdVerDay   = HardwareData.byHwdVerDay;
    *pwHwdVerYear   = HardwareData.wHwdVerYear;
    *pnRamSize      = HardwareData.nRamSize;
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusHardware2(int *pnIoUnitType, 
                                                  unsigned char *pbyHwdVerMonth, 
                                                  unsigned char *pbyHwdVerDay, 
                                                  short *pwHwdVerYear, int *pnRamSize, 
                                                  BSTR * pbstrPartNumber,
                                                  int *pnResult)
{
  USES_CONVERSION; // for string conversion

  SIOMM_StatusHardware2 HardwareData;

  *pnResult = m_MemMap.GetStatusHardwareEx2(&HardwareData);
  
  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pnIoUnitType    = HardwareData.nIoUnitType;
    *pbyHwdVerMonth  = HardwareData.byHwdVerMonth;
    *pbyHwdVerDay    = HardwareData.byHwdVerDay;
    *pwHwdVerYear    = HardwareData.wHwdVerYear;
    *pnRamSize       = HardwareData.nRamSize;   

    // Make sure the part number string is null terminated.
    char pchPartNumberTemp[SIOMM_STATUS_READ_PART_NUMBER_SIZE + 1];
    memcpy(pchPartNumberTemp, HardwareData.byPartNumber, SIOMM_STATUS_READ_PART_NUMBER_SIZE);
    pchPartNumberTemp[SIOMM_STATUS_READ_PART_NUMBER_SIZE] = 0;
    *pbstrPartNumber = A2BSTR(pchPartNumberTemp);
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusNetwork2(short * pwMACAddress0, short * pwMACAddress1, 
                                                  short * pwMACAddress2, int * pnTCPIPAddress, 
                                                  int * pnSubnetMask, int * pnDefGateway, 
                                                  int * pnTcpIpMinRtoMS, int * pnInitialRtoMS, 
                                                  int * pnTcpRetries, int * pnTcpIdleTimeout, 
                                                  int * pnEnetLateCol, int * pnEnetExcessiveCol, 
                                                  int * pnEnetOtherErrors, int * pnResult)
{
  SIOMM_StatusNetwork2 NetworkData;

  *pnResult = m_MemMap.GetStatusNetworkEx2(&NetworkData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pwMACAddress0      = NetworkData.wMACAddress0;
    *pwMACAddress1      = NetworkData.wMACAddress1;
    *pwMACAddress2      = NetworkData.wMACAddress2;
    *pnTCPIPAddress     = NetworkData.nTCPIPAddress;
    *pnSubnetMask       = NetworkData.nSubnetMask;
    *pnDefGateway       = NetworkData.nDefGateway;
    *pnTcpIpMinRtoMS    = NetworkData.nTcpIpMinRtoMS;
    *pnInitialRtoMS     = NetworkData.nInitialRtoMS;
    *pnTcpRetries       = NetworkData.nTcpRetries;
    *pnTcpIdleTimeout   = NetworkData.nTcpIdleTimeout;
    *pnEnetLateCol      = NetworkData.nEnetLateCol;
    *pnEnetExcessiveCol = NetworkData.nEnetExcessiveCol;
    *pnEnetOtherErrors  = NetworkData.nEnetOtherErrors;
  }
  
  return S_OK;
}



STDMETHODIMP CO22SnapIoMemMapX::GetStatusNetwork(short *pwMACAddress0, short *pwMACAddress1, 
                                                 short *pwMACAddress2, int *pnTCPIPAddress, 
                                                 int *pnSubnetMask, int *pnDefGateway, 
                                                 int *pnResult)
{
  SIOMM_StatusNetwork NetworkData;

  *pnResult = m_MemMap.GetStatusNetworkEx(&NetworkData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    *pwMACAddress0  = NetworkData.wMACAddress0;
    *pwMACAddress1  = NetworkData.wMACAddress1;
    *pwMACAddress2  = NetworkData.wMACAddress2;
    *pnTCPIPAddress = NetworkData.nTCPIPAddress;
    *pnSubnetMask   = NetworkData.nSubnetMask;
    *pnDefGateway   = NetworkData.nDefGateway;
  }
  
  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusPUC(int *pnPUCFlag, int *pnResult)
{
  *pnResult = m_MemMap.GetStatusPUC(pnPUCFlag);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusLastError(int *pnErrorCode, int *pnResult)
{
  *pnResult = m_MemMap.GetStatusLastError(pnErrorCode);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusBootpAlways(int *pnBootpAlways, int *pnResult)
{
  *pnResult = m_MemMap.GetStatusBootpAlways(pnBootpAlways);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusDegrees(int *pnDegrees, int *pnResult)
{
  *pnResult = m_MemMap.GetStatusDegrees(pnDegrees);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStatusWatchdogTime(int *pnTimeMS, int *pnResult)
{
  *pnResult = m_MemMap.GetStatusWatchdogTime(pnTimeMS);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetStatusOperation(int nOpCode, int *pnResult)
{
  *pnResult = m_MemMap.SetStatusOperation(nOpCode);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetStatusBootpRequest(int nFlag, int *pnResult)
{
  *pnResult = m_MemMap.SetStatusBootpRequest(nFlag);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetStatusDegrees(int nDegFlag, int *pnResult)
{
  *pnResult = m_MemMap.SetStatusDegrees(nDegFlag);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetStatusWatchdogTime(int nTimeMS, int *pnResult)
{
  *pnResult = m_MemMap.SetStatusWatchdogTime(nTimeMS);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetDateTime(BSTR *pbstrDateTime, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  char pchDateTimeTemp[SIOMM_DATE_AND_TIME_SIZE];

  *pnResult = m_MemMap.GetDateTime(pchDateTimeTemp);

  if (SIOMM_OK == *pnResult)
  {
    *pbstrDateTime = A2BSTR(pchDateTimeTemp);
  }

  return S_OK;
}
STDMETHODIMP CO22SnapIoMemMapX::SetDateTime(BSTR bstrDateTime, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.SetDateTime(OLE2A(bstrDateTime));

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetDigPtReadAreaEx(int nPoint, O22_SIOMM_DigPointReadArea *pPointData, int *pnResult)
{
  *pnResult = m_MemMap.GetDigPtReadAreaEx(nPoint, pPointData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetDigBankReadAreaEx(O22_SIOMM_DigBankReadArea *pBankData, int *pnResult)
{
  *pnResult = m_MemMap.GetDigBankReadAreaEx(pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaPtReadAreaEx(int nPoint, O22_SIOMM_AnaPointReadArea *pPointData, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaPtReadAreaEx(nPoint, pPointData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetDigBankPointStates(int nPts63to32, int nPts31to0, 
                                                      int nMask63to32, int nMask31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetDigBankPointStates(nPts63to32, nPts31to0, nMask63to32, nMask31to0);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaBankValuesEx(O22_SIOMM_AnaBank *pBankData, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaBankValuesEx(pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaBankCountsEx(O22_SIOMM_AnaBank *pBankData, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaBankCountsEx(pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaBankMinValuesEx(O22_SIOMM_AnaBank *pBankData, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaBankMinValuesEx(pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnaBankMaxValuesEx(O22_SIOMM_AnaBank *pBankData, int *pnResult)
{
  *pnResult = m_MemMap.GetAnaBankMaxValuesEx(pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaBankValuesEx(O22_SIOMM_AnaBank * pBankData, int *pnResult)
{
  *pnResult = m_MemMap.SetAnaBankValuesEx(*pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnaBankCountsEx(O22_SIOMM_AnaBank * pBankData, int *pnResult)
{
  *pnResult = m_MemMap.SetAnaBankCountsEx(*pBankData);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetCommOptions(int nTimeOutMS, int nReserved, int *pnResult)
{
  *pnResult = m_MemMap.SetCommOptions(nTimeOutMS, nReserved);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::WriteLong(int nOffset, int nValue, int *pnResult)
{
  *pnResult = m_MemMap.WriteQuad( nOffset, nValue);

	return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadLong(int nOffset, int *pnValue, int *pnResult)
{
  uint32_t value;
  *pnResult = m_MemMap.ReadQuad( nOffset, &value);
  *pnValue = (int)value;

	return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::WriteFloat(int nOffset, float fValue, int *pnResult)
{
  *pnResult = m_MemMap.WriteFloat( nOffset, fValue);

	return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadFloat(int nOffset, float *pfValue, int *pnResult)
{
  *pnResult = m_MemMap.ReadFloat(nOffset, pfValue);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::VOpenEnet(VARIANT strIpAddressArg, VARIANT nPort, 
                                          VARIANT nOpenTimeOutMS,  VARIANT nAutoPUC, 
                                          VARIANT *pnResult)
{
  CHECK_VARIANT_IS_BSTR(strIpAddressArg);
  CHECK_VARIANT_IS_LONG(nPort);
  CHECK_VARIANT_IS_LONG(nOpenTimeOutMS);
  CHECK_VARIANT_IS_LONG(nAutoPUC);
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = OpenEnet(strIpAddressArg.bstrVal, nPort.lVal, nOpenTimeOutMS.lVal, nAutoPUC.lVal, &resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VIsOpenDone(VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = IsOpenDone(&resultVal);
  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VClose(VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = Close(&resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetCommOptions(VARIANT nTimeOutMS, VARIANT nReserved, 
                                                VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nTimeOutMS);
  CHECK_VARIANT_IS_LONG(nReserved);
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = SetCommOptions(nTimeOutMS.lVal, nReserved.lVal, &resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VConfigurePoint(VARIANT nPoint, VARIANT nPointType, 
                                                VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_LONG(nPointType);
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = SetCommOptions(nPoint.lVal, nPointType.lVal, &resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetPtConfiguration(VARIANT nPoint, VARIANT nPointType, 
                                                    VARIANT nFeature, VARIANT fOffVSet, 
                                                    VARIANT fGain, VARIANT fLoScale, 
                                                    VARIANT fHiScale, VARIANT fWatchdogValue, 
                                                    VARIANT nWatchdogEnabled, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_LONG(nPointType);
  CHECK_VARIANT_IS_LONG(nFeature);
  CHECK_VARIANT_IS_FLOAT(fOffVSet);
  CHECK_VARIANT_IS_FLOAT(fGain);
  CHECK_VARIANT_IS_FLOAT(fLoScale);
  CHECK_VARIANT_IS_FLOAT(fHiScale);
  CHECK_VARIANT_IS_FLOAT(fWatchdogValue);
  CHECK_VARIANT_IS_LONG(nWatchdogEnabled);
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = SetPtConfiguration(nPoint.lVal, nPointType.lVal, nFeature.lVal, 
                            fOffVSet.fltVal, fGain.fltVal, fLoScale.fltVal, fHiScale.fltVal,
                            fWatchdogValue.fltVal, nWatchdogEnabled.lVal,
                            &resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetPtConfiguration(VARIANT nPoint, VARIANT *pnModuleType, 
                                                    VARIANT *pnPointType, VARIANT *pnFeature, 
                                                    VARIANT *pfOffVSet, VARIANT *pfGain, 
                                                    VARIANT *pfLoScale, VARIANT *pfHiScale, 
                                                    VARIANT *pfWatchdogValue, 
                                                    VARIANT *pnWatchdogEnabled, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnModuleType);
  SET_VARIANT_AS_LONG(pnPointType);
  SET_VARIANT_AS_LONG(pnFeature);
  SET_VARIANT_AS_FLOAT(pfOffVSet);
  SET_VARIANT_AS_FLOAT(pfGain);
  SET_VARIANT_AS_FLOAT(pfLoScale);
  SET_VARIANT_AS_FLOAT(pfHiScale);
  SET_VARIANT_AS_FLOAT(pfWatchdogValue);
  SET_VARIANT_AS_LONG(pnWatchdogEnabled);
  SET_VARIANT_AS_LONG(pnResult);

  int moduleType, pointType, feature, watchdogEnabled, result;
  HRESULT hr = GetPtConfiguration(nPoint.lVal, &moduleType, &pointType,
                            &feature, &(pfOffVSet->fltVal), &(pfGain->fltVal), 
                            &(pfLoScale->fltVal), &(pfHiScale->fltVal),
                            &(pfWatchdogValue->fltVal), &watchdogEnabled,
                            &result);

  pnModuleType->lVal = moduleType;
  pnPointType->lVal = pointType;
  pnFeature->lVal = feature;
  pnWatchdogEnabled->lVal = watchdogEnabled;
  pnResult->lVal = result;

  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetPtWatchdog(VARIANT nPoint, VARIANT fValue, VARIANT nEnabled, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_LONG(nEnabled);
  CHECK_VARIANT_IS_FLOAT(fValue);
  SET_VARIANT_AS_LONG(pnResult);

  int resultVal;
  HRESULT hr = SetPtWatchdog(nPoint.lVal, fValue.fltVal, nEnabled.lVal, &resultVal);

  pnResult->lVal = resultVal;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtState(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = GetDigPtState(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtOnLatch(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = GetDigPtOnLatch(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtOffLatch(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = GetDigPtOffLatch(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtCounterState(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = GetDigPtCounterState(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtCounts(VARIANT nPoint, VARIANT *pnValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnValue);
  SET_VARIANT_AS_LONG(pnResult);

  int value, result;
  HRESULT hr = GetDigPtCounts(nPoint.lVal, &value, &result);
  pnValue->lVal = value;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigPtReadArea(VARIANT nPoint, VARIANT *pnState, 
                                                  VARIANT *pnOnLatchState, VARIANT *pnOffLatchState,
                                                  VARIANT *pnCounterActive, VARIANT *pnCounterData,
                                                  VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnOnLatchState);
  SET_VARIANT_AS_LONG(pnOffLatchState);
  SET_VARIANT_AS_LONG(pnCounterActive);
  SET_VARIANT_AS_LONG(pnCounterData);
  SET_VARIANT_AS_LONG(pnResult);

  int state, onLatchState, offLatchState, counterActive, counterData, result;
  HRESULT hr = GetDigPtReadArea(nPoint.lVal, &state, 
                          &onLatchState, &offLatchState, 
                          &counterActive, &counterData, 
                          &result);

  pnState->lVal = state;
  pnOnLatchState->lVal = onLatchState;
  pnOffLatchState->lVal = offLatchState;
  pnCounterActive->lVal = counterActive;
  pnCounterData->lVal = counterData;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigPtState(VARIANT nPoint, VARIANT nState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_LONG(nState);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigPtState(nPoint.lVal, nState.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigPtCounterState(VARIANT nPoint, VARIANT nState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_LONG(nState);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigPtCounterState(nPoint.lVal, nState.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigBankPointStates(VARIANT *pnPts63to32, VARIANT *pnPts31to0, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnPts63to32);
  SET_VARIANT_AS_LONG(pnPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int points63To32, points31To0, result;
  HRESULT hr = GetDigBankPointStates(&points63To32, &points31To0, &result);
  pnPts63to32->lVal = points63To32;
  pnPts31to0->lVal = points31To0;
  pnResult->lVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::VGetDigBankOnLatchStates(VARIANT *pnPts63to32, VARIANT *pnPts31to0, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnPts63to32);
  SET_VARIANT_AS_LONG(pnPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int points63To32, points31To0, result;
  HRESULT hr = GetDigBankOnLatchStates(&points63To32, &points31To0, &result);
  pnPts63to32->lVal = points63To32;
  pnPts31to0->lVal = points31To0;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigBankOffLatchStates(VARIANT *pnPts63to32, VARIANT *pnPts31to0, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnPts63to32);
  SET_VARIANT_AS_LONG(pnPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int points63To32, points31To0, result;
  HRESULT hr = GetDigBankOffLatchStates(&points63To32, &points31To0, &result);
  pnPts63to32->lVal = points63To32;
  pnPts31to0->lVal = points31To0;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigBankActCounterStates(VARIANT *pnPts63to32, VARIANT *pnPts31to0, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnPts63to32);
  SET_VARIANT_AS_LONG(pnPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int points63To32, points31To0, result;
  HRESULT hr = GetDigBankActCounterStates(&points63To32, &points31To0, &result);
  pnPts63to32->lVal = points63To32;
  pnPts31to0->lVal = points31To0;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetDigBankReadArea(VARIANT *pnStatePts63to32, 
                                                    VARIANT *pnStatePts31to0, 
                                                    VARIANT *pnOnLatchStatePts63to32, 
                                                    VARIANT *pnOnLatchStatePts31to0, 
                                                    VARIANT *pnOffLatchStatePts63to32, 
                                                    VARIANT *pnOffLatchStatePts31to0, 
                                                    VARIANT *pnActiveCountersPts63to32, 
                                                    VARIANT *pnActiveCountersPts31to0, 
                                                    VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnStatePts63to32);
  SET_VARIANT_AS_LONG(pnStatePts31to0);
  SET_VARIANT_AS_LONG(pnOnLatchStatePts63to32);
  SET_VARIANT_AS_LONG(pnOnLatchStatePts31to0);
  SET_VARIANT_AS_LONG(pnOffLatchStatePts63to32);
  SET_VARIANT_AS_LONG(pnOffLatchStatePts31to0);
  SET_VARIANT_AS_LONG(pnActiveCountersPts63to32);
  SET_VARIANT_AS_LONG(pnActiveCountersPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int statePoints63To32, statePoints31To0;
  int onLatchStatePoints63To32, onLatchStatePoints31To0;
  int offLatchStatePoints63To32, offLatchStatePoints31To0;
  int activeCountersPoints63To32, activeCountersPoints31To0;
  int result;

  HRESULT hr = GetDigBankReadArea(&statePoints63To32, &statePoints31To0, 
                            &onLatchStatePoints63To32, &onLatchStatePoints31To0, 
                            &offLatchStatePoints63To32, &offLatchStatePoints31To0, 
                            &activeCountersPoints63To32, &activeCountersPoints31To0,
                            &result);

  pnStatePts63to32->lVal = statePoints63To32;
  pnStatePts31to0->lVal = statePoints31To0;
  pnOnLatchStatePts63to32->lVal = onLatchStatePoints63To32;
  pnOnLatchStatePts31to0->lVal = onLatchStatePoints31To0;
  pnOffLatchStatePts63to32->lVal = offLatchStatePoints63To32;
  pnOffLatchStatePts31to0->lVal = offLatchStatePoints31To0;
  pnActiveCountersPts63to32->lVal = activeCountersPoints63To32;
  pnActiveCountersPts31to0->lVal = activeCountersPoints31To0;
  pnResult->llVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::VSetDigBankOnMask(VARIANT nPts63to32, VARIANT nPts31to0, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPts63to32);
  CHECK_VARIANT_IS_LONG(nPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigBankOnMask(nPts63to32.lVal, nPts31to0.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigBankOffMask(VARIANT nPts63to32, VARIANT nPts31to0, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPts63to32);
  CHECK_VARIANT_IS_LONG(nPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigBankOffMask(nPts63to32.lVal, nPts31to0.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigBankActCounterMask(VARIANT nPts63to32, VARIANT nPts31to0, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPts63to32);
  CHECK_VARIANT_IS_LONG(nPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigBankActCounterMask(nPts63to32.lVal, nPts31to0.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigBankDeactCounterMask(VARIANT nPts63to32, VARIANT nPts31to0, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPts63to32);
  CHECK_VARIANT_IS_LONG(nPts31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr =  SetDigBankDeactCounterMask(nPts63to32.lVal, nPts31to0.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetDigBankPointStates(VARIANT nPts63to32, VARIANT nPts31to0, 
                                                       VARIANT nMask63to32, VARIANT nMask31to0, 
                                                       VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPts63to32);
  CHECK_VARIANT_IS_LONG(nPts31to0);
  CHECK_VARIANT_IS_LONG(nMask63to32);
  CHECK_VARIANT_IS_LONG(nMask31to0);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetDigBankPointStates(nPts63to32.lVal, nPts31to0.lVal, nMask63to32.lVal, nMask31to0.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadClearDigPtCounts(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = ReadClearDigPtCounts(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadClearDigPtOnLatch(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = ReadClearDigPtOnLatch(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadClearDigPtOffLatch(VARIANT nPoint, VARIANT *pnState, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_LONG(pnState);
  SET_VARIANT_AS_LONG(pnResult);

  int state, result;
  HRESULT hr = ReadClearDigPtOffLatch(nPoint.lVal, &state, &result);
  pnState->lVal = state;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetAnaPtValue(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = GetAnaPtValue(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetAnaPtCounts(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = GetAnaPtCounts(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetAnaPtMinValue(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = GetAnaPtMinValue(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetAnaPtMaxValue(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = GetAnaPtMaxValue(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetAnaPtReadArea(VARIANT nPoint, VARIANT *pfValue, 
                                                  VARIANT *pfCounts, VARIANT *pfMinValue, 
                                                  VARIANT *pfMaxValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_FLOAT(pfCounts);
  SET_VARIANT_AS_FLOAT(pfMinValue);
  SET_VARIANT_AS_FLOAT(pfMaxValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = GetAnaPtReadArea(nPoint.lVal, &(pfValue->fltVal), 
                          &(pfCounts->fltVal), &(pfMinValue->fltVal), 
                          &(pfMaxValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetAnaPtValue(VARIANT nPoint, VARIANT fValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_FLOAT(fValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetAnaPtValue(nPoint.lVal, fValue.fltVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetAnaPtCounts(VARIANT nPoint, VARIANT fValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  CHECK_VARIANT_IS_FLOAT(fValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetAnaPtCounts(nPoint.lVal, fValue.fltVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadClearAnaPtMinValue(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = ReadClearAnaPtMinValue(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadClearAnaPtMaxValue(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = ReadClearAnaPtMaxValue(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VCalcSetAnaPtOffset(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = CalcSetAnaPtOffset(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VCalcSetAnaPtGain(VARIANT nPoint, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nPoint);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = CalcSetAnaPtGain(nPoint.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusVersion(VARIANT *pnMapVer, VARIANT *pnLoaderVersion, VARIANT *pnKernelVersion, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnMapVer);
  SET_VARIANT_AS_LONG(pnLoaderVersion);
  SET_VARIANT_AS_LONG(pnKernelVersion);
  SET_VARIANT_AS_LONG(pnResult);

  int mapVersion, loaderVersion, kernelVersion, result;
  HRESULT hr = GetStatusVersion(&mapVersion, &loaderVersion, &kernelVersion, &result);
  pnMapVer->lVal = mapVersion;
  pnLoaderVersion->lVal = loaderVersion;
  pnKernelVersion->lVal = kernelVersion;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusHardware(VARIANT *pnIoUnitType, VARIANT *pbyHwdVerMonth, VARIANT *pbyHwdVerDay, VARIANT *pwHwdVerYear, VARIANT *pnRamSize, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnIoUnitType);
  SET_VARIANT_AS_BYTE(pbyHwdVerMonth);
  SET_VARIANT_AS_BYTE(pbyHwdVerDay);
  SET_VARIANT_AS_WORD(pwHwdVerYear);
  SET_VARIANT_AS_LONG(pnRamSize);
  SET_VARIANT_AS_LONG(pnResult);

  int ioUnitType, ramSize, result;
  HRESULT hr = GetStatusHardware(&ioUnitType, &(pbyHwdVerMonth->bVal), 
                           &(pbyHwdVerDay->bVal), &(pwHwdVerYear->iVal),
                           &ramSize, &result);
  pnIoUnitType->lVal = ioUnitType;
  pnRamSize->lVal = ramSize;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusNetwork(VARIANT *pwMACAddress0, VARIANT *pwMACAddress1, 
                                                  VARIANT *pwMACAddress2, VARIANT *pnTCPIPAddress, 
                                                  VARIANT *pnSubnetMask, VARIANT *pnDefGateway, 
                                                  VARIANT *pnResult)
{
  SET_VARIANT_AS_WORD(pwMACAddress0);
  SET_VARIANT_AS_WORD(pwMACAddress1);
  SET_VARIANT_AS_WORD(pwMACAddress2);
  SET_VARIANT_AS_LONG(pnTCPIPAddress);
  SET_VARIANT_AS_LONG(pnSubnetMask);
  SET_VARIANT_AS_LONG(pnDefGateway);
  SET_VARIANT_AS_LONG(pnResult);

  int ipAddress, subnetMask, defaultGateway, result;
  HRESULT hr = GetStatusNetwork(&(pwMACAddress0->iVal), &(pwMACAddress1->iVal), 
                          &(pwMACAddress2->iVal), &ipAddress,
                          &subnetMask, &defaultGateway,
                          &result);
  pnTCPIPAddress->lVal = ipAddress;
  pnSubnetMask->lVal = subnetMask;
  pnDefGateway->lVal = defaultGateway;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusPUC(VARIANT *pnPUCFlag, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnPUCFlag);
  SET_VARIANT_AS_LONG(pnResult);

  int pucFlag, result;
  HRESULT hr = GetStatusPUC(&pucFlag, &result);
  pnPUCFlag->lVal = pucFlag;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusLastError(VARIANT *pnErrorCode, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnErrorCode);
  SET_VARIANT_AS_LONG(pnResult);

  int errorCode, result;
  HRESULT hr = GetStatusLastError(&errorCode, &result);
  pnErrorCode->lVal = errorCode;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusBootpAlways(VARIANT *pnBootpAlways, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnBootpAlways);
  SET_VARIANT_AS_LONG(pnResult);

  int bootpAlways, result;
  HRESULT hr = GetStatusBootpAlways(&bootpAlways, &result);
  pnBootpAlways->lVal = bootpAlways;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VGetStatusDegrees(VARIANT *pnDegrees, VARIANT *pnResult)
{
  SET_VARIANT_AS_LONG(pnDegrees);
  SET_VARIANT_AS_LONG(pnResult);

  int degrees, result;
  HRESULT hr = GetStatusDegrees(&degrees, &result);
  pnDegrees->lVal = degrees;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetStatusOperation(VARIANT nOpCode, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nOpCode);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetStatusOperation(nOpCode.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VSetStatusBootpRequest(VARIANT nFlag, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nFlag);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetStatusBootpRequest(nFlag.lVal, &result);
  pnResult->lVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::VSetStatusDegrees(VARIANT nDegFlag, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nDegFlag);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetStatusDegrees(nDegFlag.lVal, &result);
  pnResult->lVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::VSetStatusWatchdogTime(VARIANT nTimeMS, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nTimeMS);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = SetStatusWatchdogTime(nTimeMS.lVal, &result);
  pnResult->lVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::VWriteLong(VARIANT nOffset, VARIANT nValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nOffset);
  CHECK_VARIANT_IS_LONG(nValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = WriteLong(nOffset.lVal, nValue.lVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadLong(VARIANT nOffset, VARIANT *pnValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nOffset);
  SET_VARIANT_AS_LONG(pnValue);
  SET_VARIANT_AS_LONG(pnResult);

  int value, result;
  HRESULT hr = ReadLong(nOffset.lVal, &value, &result);
  pnValue->lVal = value;
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VWriteFloat(VARIANT nOffset, VARIANT fValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nOffset);
  CHECK_VARIANT_IS_FLOAT(fValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = WriteFloat(nOffset.lVal, fValue.fltVal, &result);
  pnResult->lVal = result;
  return hr;
}

STDMETHODIMP CO22SnapIoMemMapX::VReadFloat(VARIANT nOffset, VARIANT *pfValue, VARIANT *pnResult)
{
  CHECK_VARIANT_IS_LONG(nOffset);
  SET_VARIANT_AS_FLOAT(pfValue);
  SET_VARIANT_AS_LONG(pnResult);

  int result;
  HRESULT hr = ReadFloat(nOffset.lVal, &(pfValue->fltVal), &result);
  pnResult->lVal = result;
  return hr;
}


STDMETHODIMP CO22SnapIoMemMapX::SetStreamConfiguration(int nOnFlag, int nIntervalMS, int nPort,
                                                       int nIoMirroringEnabled, 
                                                       int nStartAddress, int nDataSize, 
                                                       int * pnResult)
{
  *pnResult = m_MemMap.SetStreamConfiguration(nOnFlag, nIntervalMS, nPort, nIoMirroringEnabled,
                                              nStartAddress, nDataSize);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetStreamTarget(int nTarget, BSTR bstrIpAddressArg, int * pnResult)
{
  USES_CONVERSION; // for string conversion

  *pnResult = m_MemMap.SetStreamTarget(nTarget, OLE2A(bstrIpAddressArg));

  return S_OK;

}

STDMETHODIMP CO22SnapIoMemMapX::GetStreamConfiguration(int * pnOnFlag, int * pnIntervalMS, 
                                                       int * pnPort, int * pnIoMirroringEnabled,
                                                       int * pnStartAddress, int * pnDataSize, 
                                                       int * pnResult)
{
  *pnResult = m_MemMap.GetStreamConfiguration(pnOnFlag, pnIntervalMS, pnPort, pnIoMirroringEnabled,
                                              pnStartAddress, pnDataSize);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStreamTarget(int nTarget, int * pnIpAddressArg, int * pnResult)
{
  *pnResult = m_MemMap.GetStreamTarget(nTarget, pnIpAddressArg);
 
  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStreamReadAreaEx(O22_SIOMM_StreamStandardBlock *pStreamData, int *pnResult)
{
  *pnResult = m_MemMap.GetStreamReadAreaEx(pStreamData);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::WriteBlock(int nOffset, VARIANT byBlock, short nLength, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY(byBlock);

  SAFEARRAY * pSafeArray = byBlock.parray;
  BYTE      * pbyDataBlock;

  // Lock the SafeArray
  SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  *pnResult = m_MemMap.WriteBlock(nOffset, nLength, pbyDataBlock);

  // Unlock the SafeArray
  SafeArrayUnaccessData(pSafeArray);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ReadBlock(int nOffset, VARIANT * pbyBlock, short nLength, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY((*pbyBlock));
 
  BYTE      * pbyDataBlock;
  SAFEARRAY * pSafeArray = pbyBlock->parray;
  HRESULT     hResult;
 
  // Lock the SafeArray
  hResult = SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  if (S_OK == hResult)
  {
    *pnResult = m_MemMap.ReadBlock(nOffset, nLength, pbyDataBlock);

    // Unlock the SafeArray
    SafeArrayUnaccessData(pSafeArray);

    pbyBlock->parray = pSafeArray;
  }

  return hResult;
}


STDMETHODIMP CO22SnapIoMemMapX::GetLongAtBlockIndex(VARIANT byBlock, short nIndex, 
                                                    int * pnValue, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY(byBlock);

  SAFEARRAY * pSafeArray = byBlock.parray;
  BYTE      * pbyDataBlock;

  // Check that the index is in bounds.
  if (( byBlock.parray->rgsabound->lLbound > nIndex) ||
      ((byBlock.parray->rgsabound->lLbound + 
        (int) byBlock.parray->rgsabound->cElements) < (nIndex + 4)))
  {
    return DISP_E_BADINDEX;
  }

  // Lock the SafeArray
  SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  // Reset the index
  nIndex = nIndex - (short)(byBlock.parray->rgsabound->lLbound);
  
  // Flip flop the bytes
  *pnValue = O22MAKELONG2(pbyDataBlock, nIndex);
  
  // Unlock the SafeArray
  SafeArrayUnaccessData(pSafeArray);

  *pnResult = SIOMM_OK;

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetFloatAtBlockIndex(VARIANT byBlock, short nIndex, 
                                                     float * pfValue, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY(byBlock);

  SAFEARRAY * pSafeArray = byBlock.parray;
  BYTE      * pbyDataBlock;
  int        nTemp;

  // Check that the index is in bounds.
  if (( byBlock.parray->rgsabound->lLbound > nIndex) ||
      ((byBlock.parray->rgsabound->lLbound + 
        (int) byBlock.parray->rgsabound->cElements) < (nIndex + 4)))
  {
    return DISP_E_BADINDEX;
  }

  // Lock the SafeArray
  SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  // Reset the index
  nIndex = nIndex - (short)(byBlock.parray->rgsabound->lLbound);

  // Flip flop the bytes
  nTemp = O22MAKELONG2(pbyDataBlock, nIndex);

  // Copy from the temp into the float
  memcpy(pfValue, &nTemp, sizeof(float));
  
  // Unlock the SafeArray
  SafeArrayUnaccessData(pSafeArray);

  *pnResult = SIOMM_OK;

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetLongAtBlockIndex(VARIANT * pbyBlock, short nIndex, 
                                                    int nValue, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY((*pbyBlock));

  BYTE      * pbyDataBlock;
  SAFEARRAY * pSafeArray = pbyBlock->parray;
  HRESULT     hResult;
 


  // Check that the index is in bounds.
  if (( pbyBlock->parray->rgsabound->lLbound > nIndex) ||
      ((pbyBlock->parray->rgsabound->lLbound + 
        (int) pbyBlock->parray->rgsabound->cElements) < (nIndex + 4)))
  {
    return DISP_E_BADINDEX;
  }

  // Lock the SafeArray
  hResult = SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  if (S_OK == hResult)
  {
    // Reset the index
    nIndex = nIndex - (short)(pbyBlock->parray->rgsabound->lLbound);

    // Set the bytes within the data block
    O22FILL_ARRAY_FROM_INT32(pbyDataBlock, nIndex, nValue);

    // Unlock the SafeArray
    SafeArrayUnaccessData(pSafeArray);

    pbyBlock->parray = pSafeArray;

    *pnResult = SIOMM_OK;
  }
  else
  {
    *pnResult = SIOMM_ERROR;

  }

  return hResult;
}


STDMETHODIMP CO22SnapIoMemMapX::SetFloatAtBlockIndex(VARIANT * pbyBlock, short nIndex, 
                                                     float fValue, int * pnResult)
{
  CHECK_VARIANT_IS_BYTE_ARRAY((*pbyBlock));

  BYTE      * pbyDataBlock;
  SAFEARRAY * pSafeArray = pbyBlock->parray;
  HRESULT     hResult;
 

  // Check that the index is in bounds.
  if (( pbyBlock->parray->rgsabound->lLbound > nIndex) ||
      ((pbyBlock->parray->rgsabound->lLbound + 
        (int) pbyBlock->parray->rgsabound->cElements) < (nIndex + 4)))
  {
    return DISP_E_BADINDEX;
  }

  // Lock the SafeArray
  hResult = SafeArrayAccessData(pSafeArray, (void**)&pbyDataBlock);

  if (S_OK == hResult)
  {
    // Reset the index
    nIndex = nIndex - (short)(pbyBlock->parray->rgsabound->lLbound);

    // Set the bytes within the data block
    O22FILL_ARRAY_FROM_FLOAT(pbyDataBlock, nIndex, fValue);

    // Unlock the SafeArray
    SafeArrayUnaccessData(pSafeArray);

    pbyBlock->parray = pSafeArray;

    *pnResult = SIOMM_OK;
  }
  else
  {
    *pnResult = SIOMM_ERROR;
  }

  return hResult;
}

STDMETHODIMP CO22SnapIoMemMapX::GetStreamReadArea(VARIANT * pfAnalogValues, VARIANT * pnDigPointFeature, 
                                                  int * pnStatePts63to32, int * pnStatePts31to0, 
                                                  int * pnOnLatchStatePts63to32,   int * pnOnLatchStatePts31to0, 
                                                  int * pnOffLatchStatePts63to32,  int * pnOffLatchStatePts31to0, 
                                                  int * pnActiveCountersPts63to32, int * pnActiveCountersPts31to0, 
                                                  int * pnResult)
{
  CHECK_VARIANT_IS_FLOAT_ARRAY((*pfAnalogValues));
  CHECK_VARIANT_IS_LONG_ARRAY((*pnDigPointFeature));

  // Check that the arrays are big enough
  if ((pfAnalogValues->parray->rgsabound->cElements    < SIOMM_ABANK_MAX_ELEMENTS)  || 
      (pnDigPointFeature->parray->rgsabound->cElements < SIOMM_DBANK_MAX_FEATURE_ELEMENTS))
  {
    return E_INVALIDARG;
  }
  
  SAFEARRAY * pSafeArray;

  SIOMM_StreamStandardBlock StreamData;

  *pnResult = m_MemMap.GetStreamReadAreaEx(&StreamData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    int i;
    float * pfArray;
    int  * pnArray;

    pSafeArray = pfAnalogValues->parray;
    SafeArrayAccessData(pSafeArray, (void**)&pfArray);
    for (i = 0 ; i < SIOMM_ABANK_MAX_ELEMENTS ; i++)
    {
      pfArray[i] = StreamData.fAnalogValue[i];
    }
    SafeArrayUnaccessData(pSafeArray);


    pSafeArray = pnDigPointFeature->parray;
    SafeArrayAccessData(pSafeArray, (void**)&pnArray);
    for (i = 0 ; i < SIOMM_DBANK_MAX_FEATURE_ELEMENTS ; i++)
    {
      pnArray[i] = StreamData.nDigPointFeature[i];
    }
    SafeArrayUnaccessData(pSafeArray);

    *pnStatePts63to32 = StreamData.nStatePts63to32; 
    *pnStatePts31to0 = StreamData.nStatePts31to0;
    *pnOnLatchStatePts63to32 = StreamData.nOnLatchStatePts63to32;   
    *pnOnLatchStatePts31to0 = StreamData.nOnLatchStatePts31to0;
    *pnOffLatchStatePts63to32 = StreamData.nOffLatchStatePts63to32;
    *pnOffLatchStatePts31to0 = StreamData.nOffLatchStatePts31to0;
    *pnActiveCountersPts63to32 = StreamData.nActiveCountersPts63to32;
    *pnActiveCountersPts31to0 = StreamData.nActiveCountersPts31to0;
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetSerialModuleConfigurationEx(int nSerialPort, O22_SIOMM_SerialModuleConfigArea *pConfigData, /*[out, retval]*/ int *pnResult)
{
  SIOMM_SerialModuleConfigArea ConfigData;

  *pnResult = m_MemMap.GetSerialModuleConfigurationEx(nSerialPort, &ConfigData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    memcpy(pConfigData, &ConfigData, sizeof(ConfigData));
  }

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetSerialModuleConfigurationEx(int nSerialPort, O22_SIOMM_SerialModuleConfigArea ConfigData, /*[out, retval]*/ int *pnResult)
{
  *pnResult = m_MemMap.SetSerialModuleConfigurationEx(nSerialPort, ConfigData);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetScratchPadIntegerArea(int nStartIndex, O22_SIOMM_ScratchPadIntegerBlock * pBlock, int * pnResult)
{
  int arrnData[SIOMM_SCRATCHPAD_INTEGER_MAX_ELEMENTS];

  *pnResult = m_MemMap.GetScratchPadIntegerArea(nStartIndex, 
                                                SIOMM_SCRATCHPAD_INTEGER_MAX_ELEMENTS, 
                                                arrnData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    for (int i = 0 ; i < SIOMM_SCRATCHPAD_INTEGER_MAX_ELEMENTS ; i++)
    {
      pBlock->nValue[i] = arrnData[i];
    }
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadIntegerArea(short nStartIndex, short nLength, 
                                                         O22_SIOMM_ScratchPadIntegerBlock * pBlock,
                                                         int * pnResult)
{
  *pnResult = m_MemMap.SetScratchPadIntegerArea(nStartIndex, 
                                                nLength, 
                                                pBlock->nValue);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadFloatArea(short nStartIndex, short nLength, 
                                                       O22_SIOMM_ScratchPadFloatBlock * pBlock,
                                                       int * pnResult)
{
  *pnResult = m_MemMap.SetScratchPadFloatArea(nStartIndex, 
                                                nLength, 
                                                pBlock->fValue);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetScratchPadFloatArea(int nStartIndex, O22_SIOMM_ScratchPadFloatBlock * pBlock, int * pnResult)
{
  float arrfData[SIOMM_SCRATCHPAD_FLOAT_MAX_ELEMENTS];

  *pnResult = m_MemMap.GetScratchPadFloatArea(nStartIndex, 
                                              SIOMM_SCRATCHPAD_FLOAT_MAX_ELEMENTS, 
                                              arrfData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    for (int i = 0 ; i < SIOMM_SCRATCHPAD_FLOAT_MAX_ELEMENTS ; i++)
    {
      pBlock->fValue[i] = arrfData[i];
    }
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetScratchPadBitArea(int *pnBitss63to32, int *pnBits31to0, int *pnResult)
{
  *pnResult = m_MemMap.GetScratchPadBitArea(pnBitss63to32, pnBits31to0);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadBitArea(int nBits63to32, int nBits31to0, int *pnResult)
{
  *pnResult = m_MemMap.SetScratchPadBitArea(nBits63to32, nBits31to0);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadBitAreaMask(int nOnMask63to32,  int nOnMaskPts31to0, 
                                                         int nOffMask63to32, int nOffMaskPts31to0,
                                                         int *pnResult)
{
  *pnResult = m_MemMap.SetScratchPadBitAreaMask(nOnMask63to32,  nOnMaskPts31to0, 
                                                nOffMask63to32, nOffMaskPts31to0);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetScratchPadStringArea(int nStartIndex, 
                                                        O22_SIOMM_ScratchPadStringBlock * pBlock, 
                                                        int * pnResult)
{
  SIOMM_ScratchPadString arrData[SIOMM_SCRATCHPAD_STRING_MAX_ELEMENTS];

  *pnResult = m_MemMap.GetScratchPadStringArea(nStartIndex, 
                                               SIOMM_SCRATCHPAD_STRING_MAX_ELEMENTS, 
                                               arrData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    for (int i = 0 ; i < SIOMM_SCRATCHPAD_STRING_MAX_ELEMENTS ; i++)
    {
      pBlock->String[i].wLength    = arrData[i].wLength;
      pBlock->String[i].bstrString = A2WBSTR((char*)(arrData[i].byString), arrData[i].wLength + 1);
      memcpy(pBlock->String[i].byString, arrData[i].byString, SIOMM_SCRATCHPAD_STRING_DATA_SIZE);
    }
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadStringArea(short nStartIndex, short nLength, 
                                                        O22_SIOMM_ScratchPadStringBlock * pBlock,
                                                        int * pnResult)
{
  USES_CONVERSION; // for string conversion

  SIOMM_ScratchPadString arrData[SIOMM_SCRATCHPAD_STRING_MAX_ELEMENTS];

  memset(arrData, 0, sizeof(arrData));

  for (int i = 0 ; i < nLength ; i++)
  {
    arrData[i].wLength  = (short) (SysStringLen(pBlock->String[i].bstrString));
    memcpy(arrData[i].byString, OLE2A(pBlock->String[i].bstrString), arrData[i].wLength);
  }

  *pnResult = m_MemMap.SetScratchPadStringArea(nStartIndex, nLength, arrData);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadStringAreaBin(short nStartIndex, short nLength, 
                                                           O22_SIOMM_ScratchPadStringBlock * pBlock,
                                                           int * pnResult)
{
  USES_CONVERSION; // for string conversion

  SIOMM_ScratchPadString arrData[SIOMM_SCRATCHPAD_STRING_MAX_ELEMENTS];

  memset(arrData, 0, sizeof(arrData));

  for (int i = 0 ; i < nLength ; i++)
  {
    arrData[i].wLength  = pBlock->String[i].wLength;
    memcpy(arrData[i].byString, pBlock->String[i].byString, SIOMM_SCRATCHPAD_STRING_DATA_SIZE);
  }

  *pnResult = m_MemMap.SetScratchPadStringArea(nStartIndex, nLength, arrData);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetScratchPadInteger64Area(int nStartIndex, O22_SIOMM_ScratchPadInteger64Block * pBlock, int * pnResult)
{
  int arrnData[SIOMM_SCRATCHPAD_INTEGER_64_MAX_ELEMENTS * 2];

  *pnResult = m_MemMap.GetScratchPadInteger64Area(nStartIndex, 
                                                  SIOMM_SCRATCHPAD_INTEGER_64_MAX_ELEMENTS, 
                                                  arrnData);

  // If no error on the read, go ahead and unpack the structure
  if (SIOMM_OK == *pnResult)
  {
    for (int i = 0 ; i < SIOMM_SCRATCHPAD_INTEGER_64_MAX_ELEMENTS * 2 ; i++)
    {
      pBlock->nValue[i] = arrnData[i];
    }
  }

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetScratchPadInteger64Area(short nStartIndex, short nLength, O22_SIOMM_ScratchPadInteger64Block * pBlock, int * pnResult)
{
  *pnResult = m_MemMap.SetScratchPadInteger64Area(nStartIndex, 
                                                  nLength, 
                                                  pBlock->nValue);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetHDDigitalPointState(int nModule, int nPoint, int * pnState, int * pnResult)
{
  *pnResult = m_MemMap.GetHDDigitalPointState(nModule, nPoint, pnState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetHDDigitalPointOnLatch(int nModule, int nPoint, int * pnState, int * pnResult)
{
  *pnResult = m_MemMap.GetHDDigitalPointOnLatch(nModule, nPoint, pnState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetHDDigitalPointOffLatch(int nModule, int nPoint, int * pnState, int * pnResult)
{
  *pnResult = m_MemMap.GetHDDigitalPointOffLatch(nModule, nPoint, pnState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::GetHDDigitalPointCounts(int nModule, int nPoint, int * pnCounts, int * pnResult)
{
  *pnResult = m_MemMap.GetHDDigitalPointCounts(nModule, nPoint, pnCounts);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::SetHDDigitalPointState(int nModule, int nPoint, int nState, int * pnResult)
{
  *pnResult = m_MemMap.SetHDDigitalPointState(nModule, nPoint, nState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadClearHDDigitalPointCounts(int nModule, int nPoint, int * pnCounts, int * pnResult)
{
  *pnResult = m_MemMap.ReadClearHDDigitalPointCounts(nModule, nPoint, pnCounts);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadClearHDDigitalPointOnLatch(int nModule, int nPoint, int * pnState, int * pnResult)
{
  *pnResult = m_MemMap.ReadClearHDDigitalPointOnLatch(nModule, nPoint, pnState);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ReadClearHDDigitalPointOffLatch(int nModule, int nPoint, int * pnState, int * pnResult)
{
  *pnResult = m_MemMap.ReadClearHDDigitalPointOffLatch(nModule, nPoint, pnState);

  return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnalogPointTpoPeriodEx(int nModule, int nPoint, float fValue, int *pnResult)
{
    *pnResult = m_MemMap.SetAnalogPointTpoPeriodEx(nModule, nPoint, fValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnalogPointCountsEx(int nModule, int nPoint, float fValue, int *pnResult)
{
    *pnResult = m_MemMap.SetAnalogPointCountsEx(nModule, nPoint, fValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::SetAnalogPointValueEx(int nModule, int nPoint, float fValue, int *pnResult)
{
    *pnResult = m_MemMap.SetAnalogPointValueEx(nModule, nPoint, fValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointReadAreaEx(int nModule, int nPoint, O22_SIOMM_AnaPointReadArea *pData, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointReadAreaEx(nModule, nPoint, pData);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointTpoPeriodEx(int nModule, int nPoint, float *pfValue, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointTpoPeriodEx(nModule, nPoint, pfValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointMaxValueEx(int nModule, int nPoint, float *pfValue, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointMaxValueEx(nModule, nPoint, pfValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointMinValueEx(int nModule, int nPoint, float *pfValue, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointMinValueEx(nModule, nPoint, pfValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointCountsEx(int nModule, int nPoint, float *pfValue, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointCountsEx(nModule, nPoint, pfValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::GetAnalogPointValueEx(int nModule, int nPoint, float *pfValue, int *pnResult)
{
    *pnResult = m_MemMap.GetAnalogPointValueEx(nModule, nPoint, pfValue);
    return S_OK;
}

STDMETHODIMP CO22SnapIoMemMapX::ConfigurePidLoop(int nPid, O22_SIOMM_PidLoopConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetPidLoopConfigurationEx(nPid, config);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigureEventMessage(int nMessage, O22_SIOMM_EventMsgConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetEventMsgConfigurationEx(nMessage, config);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigureDigitalEvent(int nEvent, O22_SIOMM_DigitalEventConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetDigitalEventConfigurationEx(nEvent, config);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigureAlarmEvent(int nEvent, O22_SIOMM_AlarmEventConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetAlarmEventConfigurationEx(nEvent, config);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigureSerialEvent(int nEvent, O22_SIOMM_SerialEventConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetSerialEventConfigurationEx(nEvent, config);

  return S_OK;
}


STDMETHODIMP CO22SnapIoMemMapX::ConfigureTimerEvent(int nEvent, O22_SIOMM_TimerEventConfigArea config, int * pnResult)
{
  *pnResult = m_MemMap.SetTimerEventConfigurationEx(nEvent, config);

  return S_OK;
}


/*

const DISPID  INTERFACEMASK = 0xFFFF0000;
const DISPID  DISPIDMASK    = 0x0000FFFF;

const DISPID  IDISP_INTERFACE_1  = 0x00010000;
const DISPID  IDISP_INTERFACE_2  = 0x00020000;

typedef IDispatchImpl<INTERFACE_2_NAME, &INTERFACE_ID,   &LIBRARY_ID> O22SnapIoMemMapXType;
typedef IDispatchImpl<INTERFACE_NAME,   &INTERFACE_2_ID, &LIBRARY_ID> O22SnapIoMemMapX2Type;
                      

STDMETHODIMP CO22SnapIoMemMapX::GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, 
                                              LCID lcid, DISPID* rgdispid) 
{ 
   HRESULT hr = DISP_E_UNKNOWNNAME;

   
   hr = ((O22SnapIoMemMapXType*)this)->GetIDsOfNames(riid, rgszNames, cNames, lcid, rgdispid);

   if (SUCCEEDED(hr))  
   {  
      rgdispid[0] |= IDISP_INTERFACE_2;
      return hr;
   }

   hr = ((O22SnapIoMemMapX2Type*)this)->GetIDsOfNames(riid, rgszNames, cNames, lcid, rgdispid);
   if (SUCCEEDED(hr))  
   {  
      rgdispid[0] |= IDISP_INTERFACE_1;
      return hr;
   }

   return hr; 
}

STDMETHODIMP CO22SnapIoMemMapX::Invoke(DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, 
                                       DISPPARAMS* pdispparams, VARIANT* pvarResult, 
                                       EXCEPINFO* pexcepinfo, UINT* puArgErr)
{
   DWORD dwInterface = (dispidMember & INTERFACEMASK);
   dispidMember &= DISPIDMASK; 
   switch (dwInterface)
   {
   case IDISP_INTERFACE_1:
      return ((O22SnapIoMemMapXType*)this)->Invoke(dispidMember, riid, lcid, wFlags, pdispparams,
                                          pvarResult, pexcepinfo, puArgErr);
   case IDISP_INTERFACE_2:
      return ((O22SnapIoMemMapX2Type*)this)->Invoke(dispidMember, riid, lcid, wFlags, pdispparams,
                                           pvarResult, pexcepinfo, puArgErr);
   default:
      return DISP_E_MEMBERNOTFOUND;
   }
}
*/
