//-----------------------------------------------------------------------------
//
// CO22SnapIoMemMapX.h
// Copyright (c) 1999 - 2002 by Opto 22
//
// Header for the CO22SnapIoMemMapX ActiveX class.  It is mostly a thin wrapper
// around the O22SnapIoMemMap C++ class. 
// 
//-----------------------------------------------------------------------------

#ifndef __O22SnapIoMEMMAPX_H_
#define __O22SnapIoMEMMAPX_H_


#ifdef WIN32
#ifdef _WINDOWS
#include "resource.h"       // main symbols
#endif
#endif

#include "InterfaceDefines.h"


#include <atlctl.h>

#define __O22STRCT_H

#ifndef __O22SIOMM_H_
#include "O22SIOMM.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CO22SnapIoMemMapX
class ATL_NO_VTABLE CO22SnapIoMemMapX : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<INTERFACE_NAME, &INTERFACE_ID, &LIBRARY_ID, LIBRARY_MAJOR_VERSION, LIBRARY_MINOR_VERSION>,
	public CComControl<CO22SnapIoMemMapX>,
	public IPersistStreamInitImpl<CO22SnapIoMemMapX>,
	public IOleControlImpl<CO22SnapIoMemMapX>,
	public IOleObjectImpl<CO22SnapIoMemMapX>,
	public IOleInPlaceActiveObjectImpl<CO22SnapIoMemMapX>,
	public IViewObjectExImpl<CO22SnapIoMemMapX>,
	public IOleInPlaceObjectWindowlessImpl<CO22SnapIoMemMapX>,
	public IPersistStorageImpl<CO22SnapIoMemMapX>,
	public ISpecifyPropertyPagesImpl<CO22SnapIoMemMapX>,
	public IQuickActivateImpl<CO22SnapIoMemMapX>,
	public IDataObjectImpl<CO22SnapIoMemMapX>,
	public CComCoClass<CO22SnapIoMemMapX, &CLASS_ID>
{
public:
	CO22SnapIoMemMapX()
	{
	}

  O22SnapIoMemMap m_MemMap;

DECLARE_REGISTRY_RESOURCEID(REG_RESOURCE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CO22SnapIoMemMapX)
	COM_INTERFACE_ENTRY(IDispatch)
  COM_INTERFACE_ENTRY(INTERFACE_NAME)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
END_COM_MAP()

BEGIN_PROP_MAP(CO22SnapIoMemMapX)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CO22SnapIoMemMapX)
	CHAIN_MSG_MAP(CComControl<CO22SnapIoMemMapX>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IO22SnapIoMemMapX
public:
	// These are in reverse order of the idl file.

  STDMETHOD(ConfigureTimerEvent)  (/*[in]*/ int nEvent,   /*[in]*/ O22_SIOMM_TimerEventConfigArea config,   /*[out, retval]*/ int * pnResult);
  STDMETHOD(ConfigureSerialEvent) (/*[in]*/ int nEvent,   /*[in]*/ O22_SIOMM_SerialEventConfigArea config,  /*[out, retval]*/ int * pnResult);
  STDMETHOD(ConfigureAlarmEvent)  (/*[in]*/ int nEvent,   /*[in]*/ O22_SIOMM_AlarmEventConfigArea config,   /*[out, retval]*/ int * pnResult);
  STDMETHOD(ConfigureDigitalEvent)(/*[in]*/ int nEvent,   /*[in]*/ O22_SIOMM_DigitalEventConfigArea config, /*[out, retval]*/ int * pnResult);
  STDMETHOD(ConfigureEventMessage)(/*[in]*/ int nMessage, /*[in]*/ O22_SIOMM_EventMsgConfigArea config,     /*[out, retval]*/ int * pnResult);
  STDMETHOD(ConfigurePidLoop)     (/*[in]*/ int nPid,     /*[in]*/ O22_SIOMM_PidLoopConfigArea config,      /*[out, retval]*/ int * pnResult);

  STDMETHOD(GetAnalogPointValueEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float *pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetAnalogPointCountsEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float *pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetAnalogPointMinValueEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float *pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetAnalogPointMaxValueEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float *pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetAnalogPointTpoPeriodEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float *pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetAnalogPointReadAreaEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ O22_SIOMM_AnaPointReadArea *pData, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetAnalogPointValueEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetAnalogPointCountsEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetAnalogPointTpoPeriodEx) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fValue, /*[out, retval]*/ int * pnResult);

	STDMETHOD(GetAnalogOutputClamp)    (/*[in]*/ int nPoint, /*[out]*/ float * pfLowClamp, /*[out]*/ float * pfHighClamp, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetAnalogOutputClamp)    (/*[in]*/ int nPoint, /*[in]*/  float fLowClamp,    /*[in]*/  float fHighClamp,    /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnalogOutputClampEx)  (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float * pfLowClamp, /*[out]*/ float * pfHighClamp, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetAnalogOutputClampEx)  (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/  float fLowClamp,    /*[in]*/  float fHighClamp,    /*[out, retval]*/ int * pnResult);
  STDMETHOD(CalcSetAnalogPointGain)  (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float * pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(CalcSetAnalogPointOffset)(/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float * pfValue, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointWatchdog)     (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fValue, /*[in]*/ int nEnabled, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointScale)        (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fHiScale, /*[in]*/ float fLoScale, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointOffset)       (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fOffset, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointName)         (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ BSTR bstrPointName, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointGain)         (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fGain, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointFilterWeight) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ float fFilterWeight, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetPointConfiguration)(/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ O22_SIOMM_PointConfigArea4 PointConfigData, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetPointOffset)       (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float * pfOffset, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetPointGain)         (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ float * pfGain, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetPointConfiguration)(/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ O22_SIOMM_PointConfigArea4 * pData, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetModuleType)        (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnModuleType, /*[out, retval]*/ int * pnResult);
	STDMETHOD(ConfigurePointEx)     (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ int nPointType, /*[out, retval]*/ int * pnResult);
  STDMETHOD(ReadClearHDDigitalPointOffLatch)(/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(ReadClearHDDigitalPointOnLatch) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(ReadClearHDDigitalPointCounts)  (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnCounts, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetHDDigitalPointState)   (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[in]*/ int nState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetHDDigitalPointCounts)  (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnCounts, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetHDDigitalPointOffLatch)(/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetHDDigitalPointOnLatch) (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetHDDigitalPointState)   (/*[in]*/ int nModule, /*[in]*/ int nPoint, /*[out]*/ int * pnState, /*[out, retval]*/ int * pnResult);
  STDMETHOD(SetScratchPadInteger64Area)(/*[in]*/ short nStartIndex, /*[in]*/ short nLength, /*[in]*/ O22_SIOMM_ScratchPadInteger64Block * pBlock, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetScratchPadInteger64Area)(/*[in]*/ int nStartIndex, /*[out]*/ O22_SIOMM_ScratchPadInteger64Block * pBlock, /*[out, retval]*/ int * pnResult);
  STDMETHOD(OpenSerialPassThru)(/*[in]*/ BSTR bstrIpAddressArg, /*[in]*/ int nPort, /*[in]*/ int nSerialPort, /*[in]*/ BYTE nSerialAddress, /*[in]*/ int nSerialBaudRate, /*[in]*/ int nSerialTwoWire,
                                /*[in]*/ int nOpenTimeOutMS, /*[in]*/ int nAutoPUC, /*[in]*/ int nConnectionType, /*[out, retval]*/ int * pnResult);
  STDMETHOD(OpenSerial)(/*[in]*/ int nPort, /*[in]*/ unsigned char nAddress, /*[in]*/ int nBaudRate, /*[in]*/ int nOpenTimeOutMS, /*[in]*/ int nAutoPUC, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadBitAreaMask)(int nOnMask63to32,  int nOnMaskPts31to0, int nOffMask63to32, int nOffMaskPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadStringAreaBin)(/*[in]*/short nStartIndex, short nLength, O22_SIOMM_ScratchPadStringBlock * pBlock,  /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadStringArea)   (/*[in]*/short nStartIndex, short nLength, O22_SIOMM_ScratchPadStringBlock * pBlock,  /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadFloatArea)    (/*[in]*/short nStartIndex, short nLength, O22_SIOMM_ScratchPadFloatBlock * pBlock,   /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadIntegerArea)  (/*[in]*/short nStartIndex, short nLength, O22_SIOMM_ScratchPadIntegerBlock * pBlock, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetScratchPadStringArea)   (/*[in]*/int nStartIndex, O22_SIOMM_ScratchPadStringBlock * pBlock, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetScratchPadBitArea)(int nBits63to32, int nBits31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetScratchPadBitArea)(int *pnBits63to32, int *pnBits31to0, int *pnResult);
	STDMETHOD(GetScratchPadFloatArea)(/*[in]*/int nStartIndex, O22_SIOMM_ScratchPadFloatBlock * pBlock, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetScratchPadIntegerArea)(/*[in]*/int nStartIndex, O22_SIOMM_ScratchPadIntegerBlock * pBlock, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetPtConfiguration2)(int nPoint, int * pnModuleType, int * pnPointType, int * pnFeature, float * pfOffset, float * pfGain, float * pfLoScale, float * pfHiScale, float * pfWatchdogValue, int * pnWatchdogEnabled, float * pfFilterWeight, BSTR * pbstrName, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetPtConfiguration2)(int nPoint, int nPointType, int nFeature, float fOffset, float fGain, float fLoScale, float fHiScale, float fWatchdogValue, int nWatchdogEnabled, float fFilterWeight, BSTR bstrName, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtTpoPeriod)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(SetAnaPtTpoPeriod)(int nPoint, float fValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetSerialModuleConfigurationEx)(int nSerialPort, O22_SIOMM_SerialModuleConfigArea *pConfigData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(SetSerialModuleConfigurationEx)(int nSerialPort, O22_SIOMM_SerialModuleConfigArea ConfigData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetDateTime)(/*[out]*/ BSTR *pbstrDateTime, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDateTime)(/*[in]*/  BSTR   bstrDateTime, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusNetwork2)(short * pwMACAddress0, short * pwMACAddress1, short * pwMACAddress2, int * pnTCPIPAddress, int * pnSubnetMask, int * pnDefGateway, int * pnTcpIpMinRtoMS, int * pnInitialRtoMS, int * pnTcpRetries, int * pnTcpIdleTimeout, int * pnEnetLateCol, int * pnEnetExcessiveCol, int * pnEnetOtherErrors, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusHardware2)(int * pnIoUnitType, unsigned char * pbyHwdVerMonth, unsigned char * pbyHwdVerDay, short * pwHwdVerYear, int * pnRamSize, /*[out]*/ BSTR * pbstrPartNumber, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusWatchdogTime)(int *pnTimeMS, /*[out, retval]*/ int * pnResult);
	STDMETHOD(OpenEnet2)(/*[in]*/ BSTR bstrIpAddressArg, /*[in]*/ int nPort, /*[in]*/ int nOpenTimeOutMS, /*[in]*/ int nAutoPUC, /*[in]*/ int nConnectionType, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStreamReadArea)(/*[in, out]*/ VARIANT * pfAnalogValues, /*[in, out]*/ VARIANT * pnDigPointFeature, /*[out]*/ int * pnStatePts63to32, /*[out]*/ int * pnStatePts31to0, /*[out]*/ int * pnOnLatchStatePts63to32, /*[out]*/ int * pnOnLatchStatePts31to0, /*[out]*/ int * pnOffLatchStatePts63to32, /*[out]*/ int * pnOffLatchStatePts31to0, /*[out]*/ int * pnActiveCountersPts63to32, /*[out]*/ int * pnActiveCountersPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetFloatAtBlockIndex)(/*[in, out]*/ VARIANT * pbyBlock, /*[in]*/ short nIndex, /*[in]*/ float fValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetLongAtBlockIndex)(/*[in, out]*/ VARIANT * pbyBlock, /*[in]*/ short nIndex, /*[in]*/ int nValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetFloatAtBlockIndex)(/*[in]*/ VARIANT byBlock, /*[in]*/ short nIndex, /*[out]*/ float * pfValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetLongAtBlockIndex)(/*[in]*/ VARIANT byBlock, /*[in]*/ short nIndex, /*[out]*/ int * pnValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(ReadBlock)(/*[in]*/int nOffset, /*[in, out]*/ VARIANT * pbyBlock, /*[in]*/ short nLength, /*[out, retval]*/ int * pnResult);
	STDMETHOD(WriteBlock)(/*[in]*/int nOffset, /*[in]*/ VARIANT byBlock, /*[in]*/ short nLength, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStreamReadAreaEx)(O22_SIOMM_StreamStandardBlock *pStreamData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetStreamTarget)(/*[in]*/ int nTarget, /*[out]*/ int * pnIpAddressArg, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStreamConfiguration)(/*[out]*/ int * pnOnFlag, /*[out]*/ int * pnIntervalMS, /*[out]*/ int * pnPort, /*[out]*/ int * pnIoMirroringEnabled, /*[out]*/ int * pnStartAddress, /*[out]*/ int * pnDataSize, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetStreamTarget)(/*[in]*/ int nTarget, /*[in]*/ BSTR bstrIpAddressArg, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetStreamConfiguration)(/*[in]*/ int nOnFlag, /*[in]*/ int nIntervalMS, /*[in]*/ int nPort, /*[in]*/ int nIoMirroringEnabled, /*[in]*/ int nStartAddress, /*[in]*/ int nDataSize, /*[out, retval]*/ int * pnResult);
	STDMETHOD(VReadFloat)(VARIANT nOffset, VARIANT * pfValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VWriteFloat)(VARIANT nOffset, VARIANT fValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VReadLong)(VARIANT nOffset, VARIANT * pnValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VWriteLong)(VARIANT nOffset, VARIANT nValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetStatusWatchdogTime)(VARIANT nTimeMS, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetPtWatchdog)(VARIANT nPoint, VARIANT fValue, VARIANT nEnabled, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetStatusDegrees)(VARIANT nDegFlag, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetStatusBootpRequest)(VARIANT nFlag, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetStatusOperation)(VARIANT nOpCode, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusDegrees)(VARIANT *pnDegrees, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusBootpAlways)(VARIANT *pnBootpAlways, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusLastError)(VARIANT *pnErrorCode, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusPUC)(VARIANT *pnPUCFlag, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusNetwork)(VARIANT * pwMACAddress0, VARIANT * pwMACAddress1, VARIANT * pwMACAddress2, VARIANT * pnTCPIPAddress, VARIANT * pnSubnetMask, VARIANT * pnDefGateway, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusHardware)(VARIANT * pnIoUnitType, VARIANT * pbyHwdVerMonth, VARIANT * pbyHwdVerDay, VARIANT * pwHwdVerYear, VARIANT * pnRamSize, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetStatusVersion)(VARIANT * pnMapVer, VARIANT * pnLoaderVersion, VARIANT * pnKernelVersion, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VCalcSetAnaPtGain)(VARIANT nPoint, VARIANT *pfValue, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VCalcSetAnaPtOffset)(VARIANT nPoint, VARIANT *pfValue, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VReadClearAnaPtMaxValue)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VReadClearAnaPtMinValue)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetAnaPtCounts)(VARIANT nPoint, VARIANT fValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetAnaPtValue)(VARIANT nPoint, VARIANT fValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetAnaPtReadArea)(VARIANT nPoint, VARIANT * pfValue, VARIANT * pfCounts, VARIANT * pfMinValue, VARIANT * pfMaxValue, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetAnaPtMaxValue)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetAnaPtMinValue)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetAnaPtCounts)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetAnaPtValue)(VARIANT nPoint, VARIANT * pfValue, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VReadClearDigPtOffLatch)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VReadClearDigPtOnLatch)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VReadClearDigPtCounts)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VSetDigBankPointStates)(VARIANT nPts63to32, VARIANT nPts31to0, VARIANT nMask63to32, VARIANT nMask31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetDigBankDeactCounterMask)(VARIANT nPts63to32, VARIANT nPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetDigBankActCounterMask)(VARIANT nPts63to32, VARIANT nPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetDigBankOffMask)(VARIANT nPts63to32, VARIANT nPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetDigBankOnMask)(VARIANT nPts63to32, VARIANT nPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetDigBankReadArea)(VARIANT * pnStatePts63to32, VARIANT * pnStatePts31to0, VARIANT * pnOnLatchStatePts63to32, VARIANT * pnOnLatchStatePts31to0, VARIANT * pnOffLatchStatePts63to32, VARIANT * pnOffLatchStatePts31to0, VARIANT * pnActiveCountersPts63to32, VARIANT * pnActiveCountersPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetDigBankActCounterStates)(VARIANT *pnPts63to32, VARIANT *pnPts31to0, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigBankOffLatchStates)(VARIANT *pnPts63to32, VARIANT *pnPts31to0, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigBankOnLatchStates)(VARIANT *pnPts63to32, VARIANT *pnPts31to0, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VSetDigPtCounterState)(VARIANT nPoint, VARIANT nState, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetDigPtState)(VARIANT nPoint, VARIANT nState, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetDigPtReadArea)(VARIANT nPoint, VARIANT * pnState, VARIANT * pnOnLatchState, VARIANT * pnOffLatchState, VARIANT * pnCounterActive, VARIANT * pnCounterData, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigPtCounts)(VARIANT nPoint, /*[out]*/ VARIANT *pnValue, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigPtCounterState)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigPtOffLatch)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigPtOnLatch)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetDigPtState)(VARIANT nPoint, /*[out]*/ VARIANT *pnState, /*[out, retval]*/ VARIANT *pnResult);
	STDMETHOD(VGetPtConfiguration)(VARIANT nPoint, VARIANT * pnModuleType, VARIANT * pnPointType, VARIANT * pnFeature, VARIANT * pfOffVSet, VARIANT * pfGain, VARIANT * pfLoScale, VARIANT *pfHiScale, VARIANT * pfWatchdogValue, VARIANT * pnWatchdogEnabled, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetPtConfiguration)(VARIANT nPoint, VARIANT nPointType, VARIANT nFeature, VARIANT fOffVSet, VARIANT fGain, VARIANT fLoScale, VARIANT fHiScale, VARIANT fWatchdogValue, VARIANT nWatchdogEnabled, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VConfigurePoint)(VARIANT nPoint, VARIANT nPointType, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VSetCommOptions)(VARIANT nTimeOutMS, VARIANT nReserved, /*[out,retval]*/ VARIANT * pnResult);
	STDMETHOD(VClose)(/*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VIsOpenDone)(/*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VOpenEnet)(/*[in]*/ VARIANT strIpAddressArg, /*[in]*/ VARIANT  nPort, /*[in]*/ VARIANT nOpenTimeOutMS, /*[in]*/ VARIANT nAutoPUC, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(VGetDigBankPointStates)(/*[out]*/ VARIANT * pnPts63to32, /*[out]*/ VARIANT * pnPts31to0, /*[out, retval]*/ VARIANT * pnResult);
	STDMETHOD(ReadFloat)(int nOffset, float * pfValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(WriteFloat)(int nOffset, float fValue, /*[out, retval]*/ int *pnResult);
	STDMETHOD(ReadLong)(int nOffset, int * pnValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(WriteLong)(int nOffset, int nValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetStatusWatchdogTime)(int nTimeMS, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetPtWatchdog)(int nPoint, float fValue, int nEnabled, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetCommOptions)(int nTimeOutMS, int nReserved, /*[out,retval]*/ int * pnResult);
	STDMETHOD(SetAnaBankCountsEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetAnaBankValuesEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaBankMaxValuesEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaBankMinValuesEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaBankCountsEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigBankPointStates)(int nPts63to32, int nPts31to0, int nMask63to32, int nMask31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaBankValuesEx)(O22_SIOMM_AnaBank * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtReadAreaEx)(int nPoint, O22_SIOMM_AnaPointReadArea * pPointData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigBankReadAreaEx)(O22_SIOMM_DigBankReadArea * pBankData, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigPtReadAreaEx)(int nPoint, O22_SIOMM_DigPointReadArea *pPointData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(SetStatusDegrees)(int nDegFlag, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetStatusBootpRequest)(int nFlag, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetStatusOperation)(int nOpCode, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusDegrees)(int *pnDegrees, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusBootpAlways)(int *pnBootpAlways, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusLastError)(int *pnErrorCode, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusPUC)(int *pnPUCFlag, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusNetwork)(short * pwMACAddress0, short * pwMACAddress1, short * pwMACAddress2, int * pnTCPIPAddress, int * pnSubnetMask, int * pnDefGateway, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusHardware)(int * pnIoUnitType, unsigned char * pbyHwdVerMonth, unsigned char * pbyHwdVerDay, short * pwHwdVerYear, int * pnRamSize, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetStatusVersion)(int * pnMapVer, int * pnLoaderVersion, int * pnKernelVersion, /*[out,retval]*/ int * pnResult);
	STDMETHOD(CalcSetAnaPtGain)(int nPoint, float *pfValue, /*[out, retval]*/ int *pnResult);
	STDMETHOD(CalcSetAnaPtOffset)(int nPoint, float *pfValue, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetPtConfiguration)(int nPoint, int * pnModuleType, int * pnPointType, int * pnFeature, float * pfOffset, float * pfGain, float * pfLoScale, float * pfHiScale, float * pfWatchdogValue, int * pnWatchdogEnabled, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetPtConfiguration)(int nPoint, int nPointType, int nFeature, float fOffset, float fGain, float fLoScale, float fHiScale, float fWatchdogValue, int nWatchdogEnabled, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetAnaPtConfiguration)(int nPoint, int nPointType, float fOffset, float fGain, float fHiScale, float fLoScale, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigPtConfiguration)(int nPoint, int nPointType, int nFeature, /*[out, retval]*/ int * pnResult);
	STDMETHOD(ReadClearAnaPtMaxValue)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(ReadClearAnaPtMinValue)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(SetAnaPtCounts)(int nPoint, float fValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetAnaPtValue)(int nPoint, float fValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtReadArea)(int nPoint, float * pfValue, float * pfCounts, float * pfMinValue, float * pfMaxValue, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtMaxValue)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtMinValue)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtCounts)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(GetAnaPtValue)(int nPoint, float * pfValue, /*[out,retval]*/ int * pnResult);
	STDMETHOD(ReadClearDigPtOffLatch)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(ReadClearDigPtOnLatch)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(ReadClearDigPtCounts)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(SetDigPtCounterState)(int nPoint, int nState, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigPtReadArea)(int nPoint, int * pnState, int * pnOnLatchState, int * pnOffLatchState, int * pnCounterActive, int * pnCounterData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetDigPtCounts)(int nPoint, /*[out]*/ int *pnValue, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetDigPtCounterState)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetDigPtOffLatch)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(GetDigPtOnLatch)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(SetDigBankDeactCounterMask)(int nPts63to32, int nPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigBankActCounterMask)(int nPts63to32, int nPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigBankOffMask)(int nPts63to32, int nPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigBankOnMask)(int nPts63to32, int nPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigBankReadArea)(int * pnStatePts63to32, int * pnStatePts31to0, int * pnOnLatchStatePts63to32, int * pnOnLatchStatePts31to0, int * pnOffLatchStatePts63to32, int * pnOffLatchStatePts31to0, int * pnActiveCountersPts63to32, int * pnActiveCountersPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigBankActCounterStates)(int *pnPts63to32, int *pnPts31to0, int *pnResult);
	STDMETHOD(GetDigBankOffLatchStates)(int *pnPts63to32, int *pnPts31to0, int *pnResult);
	STDMETHOD(GetDigBankOnLatchStates)(int *pnPts63to32, int *pnPts31to0, int *pnResult);
	STDMETHOD(GetDigBankPointStates)(/*[out]*/ int * pnPts63to32, /*[out]*/ int * pnPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(ConfigurePoint)(int nPoint, int nPointType, /*[out, retval]*/ int * pnResult);
	STDMETHOD(SetDigPtState)(int nPoint, int nState, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetDigPtState)(int nPoint, /*[out]*/ int *pnState, /*[out, retval]*/ int *pnResult);
	STDMETHOD(Close)(/*[out, retval]*/ int * pnResult);
	STDMETHOD(IsOpenDone)(/*[out, retval]*/ int * pnResult);
	STDMETHOD(OpenEnet)(/*[in]*/ BSTR bstrIpAddressArg, /*[in]*/ int nPort, /*[in]*/ int nOpenTimeOutMS, /*[in]*/ int nAutoPUC, /*[out, retval]*/ int * pnResult);


#ifdef WIN32
#ifdef _WINDOWS
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
/*
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("O22SnapIoMemMapX");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

*/
		return S_OK;
	}
#endif 
#endif 


public :


};

#endif //__O22SNAPIOMEMMAPX_H_
