//-----------------------------------------------------------------------------
//
// CO22SnapIoStreamX.h
// Copyright (c) 1999 - 2002 by Opto 22
//
// Header for the CO22SnapIoStreamX ActiveX class.  It is mostly a thin 
// wrapper around the O22SnapIoStream C++ class. 
// 
//-----------------------------------------------------------------------------

#ifndef __OPTOSNAPIOSTREAMX_H_
#define __OPTOSNAPIOSTREAMX_H_

#ifdef WIN32
#ifdef _WINDOWS
#include "resource.h"       // main symbols

#define LIBRARY_NAME               OptoSnapIoMemMapXLib
#define LIBRARY_ID                 LIBID_OptoSnapIoMemMapXLib
 
#define STREAM_INTERFACE_NAME      IO22SnapIoStreamX
#define STREAM_CLASS_NAME          OptoSnapIoStreamX
#define STREAM_INTERFACE_ID        IID_IO22SnapIoStreamX
#define STREAM_EVENT_INTERFACE_ID  DIID__IOptoSnapIoStreamXEvents
#define STREAM_CLASS_ID            CLSID_OptoSnapIoStreamX
#define STREAM_REG_RESOURCE        IDR_O22SNAPIOMEMMAPX

#endif
#endif




#include <atlctl.h>

#define __O22STRCT_H

#ifndef __O22SIOST_H_
#include "O22SIOST.h"
#endif

#include "OptoSnapIoStreamXCP.h"

/////////////////////////////////////////////////////////////////////////////
// CO22SnapIoStreamX
class ATL_NO_VTABLE CO22SnapIoStreamX : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<STREAM_INTERFACE_NAME, &STREAM_INTERFACE_ID, &LIBRARY_ID, 2, 0>,
	public CComControl<CO22SnapIoStreamX>,
	public IPersistStreamInitImpl<CO22SnapIoStreamX>,
	public IOleControlImpl<CO22SnapIoStreamX>,
	public IOleObjectImpl<CO22SnapIoStreamX>,
	public IOleInPlaceActiveObjectImpl<CO22SnapIoStreamX>,
	public IViewObjectExImpl<CO22SnapIoStreamX>,
	public IOleInPlaceObjectWindowlessImpl<CO22SnapIoStreamX>,
	public IPersistStorageImpl<CO22SnapIoStreamX>,
	public ISpecifyPropertyPagesImpl<CO22SnapIoStreamX>,
	public IQuickActivateImpl<CO22SnapIoStreamX>,
	public IDataObjectImpl<CO22SnapIoStreamX>,
	public IProvideClassInfo2Impl<&STREAM_CLASS_ID, &STREAM_EVENT_INTERFACE_ID, &LIBRARY_ID, 2, 0>,
	public CComCoClass<CO22SnapIoStreamX, &STREAM_CLASS_ID>,
	public CProxy_O22SnapIoStreamXEvents< CO22SnapIoStreamX >,
	public IConnectionPointContainerImpl<CO22SnapIoStreamX>
{
public:
	CO22SnapIoStreamX()
	{
	}

  O22SnapIoStream m_Stream;

DECLARE_REGISTRY_RESOURCEID(IDR_O22SNAPIOMEMMAPX)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CO22SnapIoStreamX)
	COM_INTERFACE_ENTRY(STREAM_INTERFACE_NAME)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CO22SnapIoStreamX)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROP_MAP()

BEGIN_MSG_MAP(CO22SnapIoStreamX)
	CHAIN_MSG_MAP(CComControl<CO22SnapIoStreamX>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()


// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

BEGIN_CONNECTION_POINT_MAP(CO22SnapIoStreamX)
	CONNECTION_POINT_ENTRY(STREAM_EVENT_INTERFACE_ID)
END_CONNECTION_POINT_MAP()

#ifdef WIN32
#ifdef _WINDOWS
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("O22SnapIoStreamX");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}
#endif 
#endif 


// IOptoSnapIoStreamX
public:

	STDMETHOD(GetLastStreamCustomBlockEx)(O22_SIOMM_StreamCustomBlock *pStreamData, /*[out, retval]*/ int *pnResult);
	STDMETHOD(StopStreamListening)(/*[in]*/ BSTR bstrIpAddressArg, /*[out, retval]*/ int * pnResult);
	STDMETHOD(StartStreamListening)(/*[in]*/ BSTR bstrIpAddressArg, /*[in]*/ int nTimeoutMS, /*[out, retval]*/ int * pnResult);
	STDMETHOD(GetLastStreamStandardBlock)(/*[out]*/ int * pnIpAddressArg, /*[in, out]*/ VARIANT * pfAnalogValues, /*[in, out]*/ VARIANT * pnDigPointFeature, /*[out]*/ int * pnStatePts63to32, /*[out]*/ int * pnStatePts31to0, /*[out]*/ int * pnOnLatchStatePts63to32, /*[out]*/ int * pnOnLatchStatePts31to0, /*[out]*/ int * pnOffLatchStatePts63to32, /*[out]*/ int * pnOffLatchStatePts31to0, /*[out]*/ int * pnActiveCountersPts63to32, /*[out]*/ int * pnActiveCountersPts31to0, /*[out, retval]*/ int * pnResult);
	STDMETHOD(_HandleStreamEvent)(/*[in]*/int nIPAddress, /*[in]*/ int nResult);	
  STDMETHOD(CloseStreaming)(/*[out, retval]*/ int * pnResult);
	STDMETHOD(OpenStreaming)(/*[in]*/ int nType, /*[in]*/ int nLength, /*[in]*/ int nPort, /*[out, retval]*/ int * pnResult);
  STDMETHOD(GetLastStreamStandardBlockEx)(O22_SIOMM_StreamStandardBlock *pStreamData, /*[out, retval]*/ int *pnResult);

  int FireStreamEvent(int nIpAddress, int nResult);
  LPSTREAM   g_pStm;
  CComPtr<STREAM_INTERFACE_NAME> m_pProxy;

};

#endif //__OPTOSNAPIOSTREAMX_H_
