//-----------------------------------------------------------------------------
//
// CO22SnapIoVariantUtilX.h
// Copyright (c) 1999 - 2002 by Opto 22
//
// Useful macros for dealing with VARIANTs
// 
//-----------------------------------------------------------------------------

#ifndef __CO22SNAPIOVARIANTUTIL_H
#define __CO22SNAPIOVARIANTUTIL_H


#define SET_VARIANT_AS_BYTE(v)  (v)->vt = VT_UI1
#define SET_VARIANT_AS_WORD(v)  (v)->vt = VT_I2
#define SET_VARIANT_AS_LONG(v)  (v)->vt = VT_I4
#define SET_VARIANT_AS_FLOAT(v) (v)->vt = VT_R4
#define SET_VARIANT_AS_BSTR(v)  (v)->vt = VT_BSTR
#define SET_VARIANT_AS_BYTE_ARRAY(v)  (v)->vt = VT_UI1 | VT_ARRAY

#define CHECK_VARIANT_IS_BYTE(v)  if (v.vt != VT_UI1)  return E_INVALIDARG 
#define CHECK_VARIANT_IS_WORD(v)  if (v.vt != VT_I2)   return E_INVALIDARG 
#define CHECK_VARIANT_IS_LONG(v)  if (v.vt != VT_I4)   return E_INVALIDARG 
#define CHECK_VARIANT_IS_FLOAT(v) if (v.vt != VT_R4)   return E_INVALIDARG 
#define CHECK_VARIANT_IS_BSTR(v)  if (v.vt != VT_BSTR) return E_INVALIDARG 
#define CHECK_VARIANT_IS_BYTE_ARRAY(v)  if (!((v.vt & VT_ARRAY) && (v.vt & VT_UI1))) return E_INVALIDARG 
#define CHECK_VARIANT_IS_LONG_ARRAY(v)  if (!((v.vt & VT_ARRAY) && (v.vt & VT_I4)))  return E_INVALIDARG 
#define CHECK_VARIANT_IS_FLOAT_ARRAY(v) if (!((v.vt & VT_ARRAY) && (v.vt & VT_R4)))  return E_INVALIDARG 

/* This is not needed right now, but it might be useful in the future.
HRESULT ghResult;
#define FORCE_VARIANT_AS_BYTE(v)   if ((v)->vt != VT_UI4)  if (S_OK != (ghResult = VariantChangeType(v, v, 0, VT_UI1)))  return ghResult
#define FORCE_VARIANT_AS_WORD(v)   if ((v)->vt != VT_I2)   if (S_OK != (ghResult = VariantChangeType(v, v, 0, VT_I2)))   return ghResult
#define FORCE_VARIANT_AS_LONG(v)   if ((v)->vt != VT_I4)   if (S_OK != (ghResult = VariantChangeType(v, v, 0, VT_I4)))   return ghResult
#define FORCE_VARIANT_AS_FLOAT(v)  if ((v)->vt != VT_R4)   if (S_OK != (ghResult = VariantChangeType(v, v, 0, VT_R4)))   return ghResult
#define FORCE_VARIANT_AS_BSTR(v)   if ((v)->vt != VT_BSTR) if (S_OK != (ghResult = VariantChangeType(v, v, 0, VT_BSTR))) return ghResult
*/

#endif //  __CO22SNAPIOVARIANTUTIL_H
