VERSION 5.00
Begin VB.Form fMainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "OptoSnapIoMemMapX Digital Bank Example "
   ClientHeight    =   4920
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   7740
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4920
   ScaleWidth      =   7740
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame3 
      Caption         =   "Receive"
      Height          =   2175
      Left            =   2520
      TabIndex        =   12
      Top             =   2520
      Width           =   5055
      Begin VB.TextBox ReceiveText 
         BackColor       =   &H8000000F&
         Enabled         =   0   'False
         Height          =   1575
         Left            =   240
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   13
         Top             =   360
         Width           =   4575
      End
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   250
      Left            =   7080
      Top             =   4560
   End
   Begin VB.Frame Frame4 
      Caption         =   "Send"
      Height          =   2175
      Left            =   2520
      TabIndex        =   10
      Top             =   120
      Width           =   5055
      Begin VB.TextBox SendText 
         Height          =   1575
         Left            =   240
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   11
         Top             =   360
         Width           =   4575
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Configuration"
      Height          =   2895
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   2175
      Begin VB.TextBox IpAddressEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   7
         Text            =   "10.192.54.123"
         Top             =   600
         Width           =   1575
      End
      Begin VB.CommandButton ConnectBtn 
         Caption         =   "Connect"
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton DisconnectBtn 
         Caption         =   "Disconnect"
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   2280
         Width           =   1455
      End
      Begin VB.TextBox PortNumberEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   4
         Text            =   "22516"
         Top             =   1320
         Width           =   1575
      End
      Begin VB.Label Label1 
         Caption         =   "IP Address of SNAP I/O:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Module Port Number:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   1080
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Status"
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   3240
      Width           =   2175
      Begin VB.TextBox ErrorEdit 
         BackColor       =   &H00FFFFFF&
         Height          =   525
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   1
         Top             =   600
         Width           =   1575
      End
      Begin VB.Label Label3 
         Caption         =   "Error: "
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.Menu HELP_MENU 
      Caption         =   "Help"
      Begin VB.Menu HELP_ABOUT 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "fMainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal N As Integer)

Public gSerialModule As OptoSnapIoSerialModuleX


Public Sub HandleError(nResult As Long)
  ' Update the error message
  ErrorEdit.Text = GetResultAsString(nResult)
  
  If (nResult = SIOMM_OK) Then
    ' Set background to white
    ErrorEdit.BackColor = &HFFFFFF
  Else
    ' Set background to red
    ErrorEdit.BackColor = &H4444FF
    
    ' shutdown everything on a bad error
    If (nResult <> SIOMM_ERROR_NOT_CONNECTED_YET) Then
      gSerialModule.Close
      Timer1.Enabled = False
    End If
  End If
End Sub

  
Private Sub SetControlStates(bConnected As Boolean)

  ConnectBtn.Enabled = Not bConnected
  DisconnectBtn.Enabled = bConnected
  IpAddressEdit.Enabled = Not bConnected
  PortNumberEdit.Enabled = Not bConnected
  SendText.Enabled = bConnected
  ReceiveText.Enabled = bConnected

End Sub


Private Sub ConnectBtn_Click()
  Dim nResult As Long
  
  ' Attempt to open the Snap I/O..
  nResult = gSerialModule.OpenSerialModule(IpAddressEdit.Text, PortNumberEdit.Text, 30000)
  
  ' Check the result
  If (nResult = SIOMM_OK) Then
    
    ' Sleep for a little while
    Sleep (250)
    
    ' Set the cancel flag to false
    dlgOpenSnapIo.bCancel = False
    
    ' Keep calling IsOpenDone() until we succeed, time-out, or error
    nResult = gSerialModule.IsOpenDone()
    While ((nResult = SIOMM_ERROR_NOT_CONNECTED_YET) And (Not dlgOpenSnapIo.bCancel))
      
      ' let other tasks get some CPU
      DoEvents
      
      ' Show the cancel dialog
      dlgOpenSnapIo.Show (0)
      
      ' Check the status of the open operation
      nResult = gSerialModule.IsOpenDone() ' keep trying
    Wend
    
    ' hide the cancel box
    Call dlgOpenSnapIo.Hide
    
    ' check if we should close the B3000
    If (dlgOpenSnapIo.bCancel = True) Then
      Call gSerialModule.Close
    End If
  End If
  
  ' Check the result
  HandleError (nResult)
  
  ' If no error, then enable the timer
  If (nResult = 1) Then
    Timer1.Enabled = True
    
    SetControlStates (True)
  End If
End Sub

Private Sub DisconnectBtn_Click()
  Dim nResult As Long
  Timer1.Enabled = False
  
  ' Close the connection
  nResult = gSerialModule.Close()
  
  If (nResult = SIOMM_OK) Then
    ' Even though the result was OK, show the Not Connected error
    HandleError (SIOMM_ERROR_NOT_CONNECTED)
  Else
    HandleError (nResult)
  End If
  
  SetControlStates (False)
  
End Sub


Private Sub Form_Load()

  ' Create the ActiveX object
  Set gSerialModule = New OptoSnapIoSerialModuleX
    
  ' An error hasn't occured yet, but we want it to be clear
  ' that a connection has been made yet
  HandleError (SIOMM_ERROR_NOT_CONNECTED)
    
  SetControlStates (False)
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' Turn off the timer
  Timer1.Enabled = False
  
  ' Close the connection
  Call gSerialModule.Close
  
  ' Close all forms
  Dim i As Integer
  For i = Forms.Count - 1 To 1 Step -1
      Unload Forms(i)
  Next
  
End Sub


Private Sub SendText_KeyPress(KeyAscii As Integer)
  Dim nResult As Long
  Dim DataBlock(10) As Byte
  Dim DataLength As Long
  
  DataBlock(0) = KeyAscii
  DataLength = 1
  
  ' Check for the Enter key
  If (KeyAscii = 13) Then
    ' Add a New Line character
    DataBlock(1) = 10
    DataLength = 2
  End If
    
  ' Write the character to the serial module
  nResult = gSerialModule.WriteBlock(DataBlock, DataLength)

End Sub

Private Sub Timer1_Timer()
  Dim nResult As Long
  Dim DataBlock(100) As Byte
  Dim DataString As String
  Dim nLength As Integer
  Dim i As Integer
  
  nLength = 100
    
  ' Get the digital bank read area
  nResult = gSerialModule.ReadBlock(DataBlock, nLength)
  
  If (nResult = SIOMM_OK) Then
    ' Copy the data block into a string
    For i = 0 To (nLength - 1)
      DataString = DataString + Chr(DataBlock(i))
    Next i
    
    ' Add the string to the textbox
    ReceiveText.Text = ReceiveText.Text + DataString
  Else
  End If
  
  ' Handle any errors
  HandleError (nResult)
End Sub

