//-------------------------------------------------------------------------------------------------
// FILE:  OptoSIOUtils.h
//
//-------------------------------------------------------------------------------------------------

#ifndef __OptoSIOUtils_h
#define __OptoSIOUtils_h

#define VC_EXTRALEAN            // Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components

#ifndef __O22SIOMM_H_

// Error values generated by this class
#define SIOMM_OK                             1
#define SIOMM_ERROR                         -1
#define SIOMM_TIME_OUT                      -2 
#define SIOMM_ERROR_NO_SOCKETS              -3  // Unable to access socket interface
#define SIOMM_ERROR_CREATING_SOCKET         -4
#define SIOMM_ERROR_CONNECTING_SOCKET       -5
#define SIOMM_ERROR_RESPONSE_BAD            -6
#define SIOMM_ERROR_NOT_CONNECTED_YET       -7
#define SIOMM_ERROR_OUT_OF_MEMORY           -8
#define SIOMM_ERROR_NOT_CONNECTED           -9

// Error values generated by the I/O brain itself
#define SIOMM_BRAIN_ERROR_UNDEFINED_CMD      57345
#define SIOMM_BRAIN_ERROR_INVALID_PT_TYPE    57346
#define SIOMM_BRAIN_ERROR_INVALID_FLOAT      57347
#define SIOMM_BRAIN_ERROR_PUC_EXPECTED       57348
#define SIOMM_BRAIN_ERROR_INVALID_ADDRESS    57349
#define SIOMM_BRAIN_ERROR_INVALID_CMD_LENGTH 57350
#define SIOMM_BRAIN_ERROR_RESERVED           57351
#define SIOMM_BRAIN_ERROR_BUSY               57352
#define SIOMM_BRAIN_ERROR_CANT_ERASE_FLASH   57353
#define SIOMM_BRAIN_ERROR_CANT_PROG_FLASH    57354
#define SIOMM_BRAIN_ERROR_IMAGE_TOO_SMALL    57355
#define SIOMM_BRAIN_ERROR_IMAGE_CRC_MISMATCH 57356
#define SIOMM_BRAIN_ERROR_IMAGE_LEN_MISMATCH 57357

#endif // __O22SIOMM_H_


#ifdef __AFX_H__ // for MFC only

BOOL GetBitmask64FromString(CString strBitmask, int * n63to32Part, int * n31to0Part);
//---------------------------------------------------------------------------------------
// Convert a string bitmask to an actual bitmask.  Assumes the string is in a 64-bit 
// integer format, such as "0x0000000000000000"
//---------------------------------------------------------------------------------------


CString GetResultAsString(int nResult);
//---------------------------------------------------------------------------------------
// Returns a string describing a result value.
//---------------------------------------------------------------------------------------

#endif // __AFX_H__

#endif
